(* ::Package:: *)

(*OIR Model 1.3 Disintegrations for iodine added; . J.G.Sanchez Leon,  http://diarium.usal.es/guillermo*)

BeginPackage["Biokmod`OIRModels`", "Biokmod`SysModel2`"]

qTRRetention::usage =   "qTRRetention[t ,idf, fr,  sr, ss, lambda] for an intake 1 (Bq, mg, ...) by inhalation, gives
 the retention functions for each compartment of HRTM as funtion of t, in days; 
lambda is the isotope decay constant, in day^-1, by default lambda=0" ;

RTRetention::usage = "RTRetention[idf, fr, sr, ss, lambda] for an intake 1 (Bq, mg, ...) 
by inhalation, gives the retention functions in the whole Resporiratory Tract, the flow to B 
(it is computed doing Derivative[x_Blood, t]) and the flow to OES (it is computed doing Derivative[x_OES, t]);
lambda is the isotope decay constant, in day^-1, by default lambda=0"; 

qCsInjection::usage =   "qCsInjection[lambda,t] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the retention in each compartment the day t, in days, 
after the intake happened; qCsInjection[lambda,t, period] assumed a constant daily intake 1 during a period T in days";
 
qCsInjectionBioassay::usage =  "qCsInjectionBioassay[lambda, t] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the WB retention, the fecal-24h and urine-24h excretion the day t, in days, 
after the intake happened";

qCsInjectionBioassay1::usage = "qCsInjectionBioassay1[lambda, t] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1), gives the WB retention, the fecal and urine fecal rate of excretion the day t, in days, 
after the intake happened";

qCsInjectionBioassayConst::usage ="qCsInjectionBioassayConst[lambda, t, period] For an daily intake 1 of an isotope 
with a decay constant lambda (in day^-1), during a period T gives the WB retention, the fecal and urine fecal rate of excretion the day t";
  
qCsInjectionTable::usage = 
     "qCsInjectionTable[lambda,  {t1, t2, ...}] For an intake 1 (Bq, mg, ...) of an isotope  with a decay constant lambda (in day^-1)
  gives for the days {t1, t2, ...} the intake retection fraction - IRF- for the WB content, the excretion fractions for fec-24h and urine-24-h and the irf for each compartment 
(note: Sweat, Faeces and Urine represent outside compartements, therefore IRF is the accumulated content since t = 0); 
qCsInjectionTable[lambda, {t1, t2, ...}, period] give the IRF  assuming a daily constant intake 1 during a periodo T"; 

qCsIngestion::usage =   "qCsIngestion[decaycte, t, fA] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the retention in each compartment the day t, in days, 
after the intake happened; qCsIngestion[decaycte, t, period, fA] assumed a constant daily intake 1 during a period T in days";
 
qCsIngestionBioassay::usage =  "qCsIngestionBioassay[lambda, t, fA] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the WB retention, the fecal-24h and urine-24h excretion the day t, in days, 
after the intake happened";

qCsIngestionBioassay1::usage = "qCsIngestionBioassay1[lambda, t, fA] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1), gives the WB retention, the fecal and urine fecal rate of excretion the day t, in days, 
after the intake happened";

qCsIngestionBioassayConst::usage ="qCsIngestionBioassayConst[lambda, t, period, fA] For an daily intake 1 of an isotope 
with a decay constant lambda (in day^-1), during a period T gives the WB retention, the fecal and urine fecal rate of excretion the day t";
  
qCsIngestionTable::usage = 
     "qCsIngestionTable[decaycte, {t1, t2, ...}, fA]  For an intake 1 (Bq, mg, ...) of an isotope  with a decay constant lambda (in day^-1)
gives for the days {t1, t2, ...} the intake retection fraction - IRF- for the WB content, the excretion fractions for fec-24h and 
urine-24-h and the irf for each compartment  (note: Sweat, Faeces and Urine represent outside compartements, therefore IRF is 
the accumulated content since t = 0); 
qCsIngestionTable[[lambda, {t1, t2, ...}, period, fA] gives the IRF  assuming a daily constant intake 1 during a periodo T"; 

qCsInhalation::usage = 
  "qCsInhalation[lambda, t, fA, amad, fr, sr, ss] For an intake 1 (Bq, mg, ...) of an isotope  
with a decay constant lambda (in day^-1),  gives the retention in each compartment the day t, in days, 
after the intake happened; and qCsInhalation[decaycte, t, period, fA,  idf, fr, sr, ss] assumed a constant 
daily intake 1 during a period T in days";

qCsInhalationBioassay::usage = 
  "qCsInhalationBioassay[lambda, t, fA, amad, fr, sr, ss]  For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the WB retention, the fecal-24h and urine-24h excretion the day t, in days, 
after the intake happened" ;

qCsInhalationBioassay1::usage = 
  "qCsInhalationBioassay1[lambda, t, fA, amad, fr, sr, ss] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the WB retention, the fecal and urine rate excretion 
the day t, in days, after the intake happened" ;

qCsInhalationTable::usage = "qCsInhalationTable[lambda,{t1, t2, ...}, period, fA, amad, fr, sr, ss] gives the intake retection fraction - IRF- for the WB content, 
the excretion fractions for fec-24h and urine-24-h and the IRF for each compartment 
(note: Sweat, Faeces and Urine represent outside compartements, therefore IRF is the accumulated content since t = 0) and the total in the Respiratory Tract;
lambda is the corresponding caesium isotope decay constant, in day^-1";    

qCsInhalationBioassayConst::usage = "qCsInhalationBioassayConst[lambda, t1, period, fA, amad, fr, sr, ss]
For an daily intake 1 of an isotope with a decay constant lambda (in day^-1), during a period T gives 
the WB retention, the fecal and urine fecal rate of excretion the day t";

BioassayReportCaesium::usage = 
  "BioassayReportCaesium[Injection, Acute, lambda, {t1, t2, ...}], 
BioassayReportCaesium[Injection, Constant, lambda, {t1, t2, ...}, period]
BioassayReportCaesium[Ingestion, Acute, lambda, {t1, t2, ...}, fA] 
BioassayReportCaesium[Ingestion, Constant, lambda, {t1, t2, ...},period, fA] 
BioassayReportCaesium[Inhalation, Acute, lambda, {t1, t2, ...}, fA, amad, fr, sr, ss] 
BioassayReportCaesium[Inhalation, Constant, lambda, {t1, t2, ...}, 
period, fA, amad, fr, sr, ss] gives the table with WB retention and fecal and urine excretion values" ;

qUInjection::usage =   "qUInjection[lambda,t] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the retention in each compartment the day t, in days, 
after the intake happened; qCsInjection[lambda,t, period] assumed a constant daily intake 1 during a period T in days";
 
qUInjectionBioassay::usage =  "qUInjectionBioassay[lambda, t] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the WB retention, the fecal-24h and urine-24h excretion the day t, in days, 
after the intake happened";

qUInjectionBioassay1::usage = "qUInjectionBioassay1[lambda, t] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1), gives the WB retention, the fecal and urine fecal rate of excretion the day t, in days, 
after the intake happened";

qUInjectionBioassayConst::usage ="qUInjectionBioassayConst[lambda, t, period] For an daily intake 1 of an isotope 
with a decay constant lambda (in day^-1), during a period T gives the WB retention, the fecal and urine fecal rate of excretion the day t";

qUInjectionTable::usage = 
     "qUInjectionTable[lambda,  {t1, t2, ...}] For an intake 1 (Bq, mg, ...) of an isotope  with a decay constant lambda (in day^-1)
  gives for the days {t1, t2, ...} the intake retection fraction - IRF- for the WB content, the excretion fractions for fec-24h and urine-24-h and the irf for each compartment 
(note: Sweat, Faeces and Urine represent outside compartements, therefore IRF is the accumulated content since t = 0); 
qCsInjectionTable[lambda, {t1, t2, ...}, period] give the IRF  assuming a daily consntant intake 1 during a periodo T"; 

qUIngestion::usage =   "qUIngestion[decaycte, t, fA] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the retention in each compartment the day t, in days, 
after the intake happened; qCsIngestion[decaycte, t, period, fA] assumed a constant daily intake 1 during a period T in days";
 
qUIngestionBioassay::usage =  "qUIngestionBioassay[lambda, t, fA] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the WB retention, the fecal-24h and urine-24h excretion the day t, in days, 
after the intake happened";

qUIngestionBioassay1::usage = "qUIngestionBioassay1[lambda, t, fA] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1), gives the WB retention, the fecal and urine fecal rate of excretion the day t, in days, 
after the intake happened";

qUIngestionBioassayConst::usage ="qUIngestionBioassayConst[lambda, t, period, fA] For an daily intake 1 of an isotope 
with a decay constant lambda (in day^-1), during a period T gives the WB retention, the fecal and urine fecal rate of excretion the day t";
  
qUIngestionTable::usage = 
     "qUIngestionTable[decaycte, {t1, t2, ...}, fA]  For an intake 1 (Bq, mg, ...) of an isotope  with a decay constant lambda (in day^-1)
gives for the days {t1, t2, ...} the intake retection fraction - IRF- for the WB content, the excretion fractions for fec-24h and 
urine-24-h and the irf for each compartment  (note: Sweat, Faeces and Urine represent outside compartements, therefore IRF is 
the accumulated content since t = 0); 
qCsIngestionTable[[lambda, {t1, t2, ...}, period, fA] gives the IRF  assuming a daily constant intake 1 during a periodo T"; 

qUInhalation::usage = 
  "qUInhalation[lambda, t, fA, amad, fr, sr, ss] For an intake 1 (Bq, mg, ...) of an isotope  
with a decay constant lambda (in day^-1),  gives the retention in each compartment the day t, in days, 
after the intake happened; and qCsInhalation[decaycte, t, period, fA,  idf, fr, sr, ss] assumed a constant 
daily intake 1 during a period T in days";

qUInhalationBioassay::usage = 
  "qUInhalationBioassay[lambda, t, fA, amad, fr, sr, ss]  For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the Lung and WB retention, the fecal-24h and urine-24h excretion the day t, in days, 
after the intake happened" ;

qUInhalationBioassay1::usage = 
  "qUInhalationBioassay1[lambda, t, fA, amad, fr, sr, ss] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the Lung and WB retention, the fecal and urine rate excretion 
the day t, in days, after the intake happened" ;

qUInhalationBioassay2::usage = 
  "qUInhalationBioassay1[lambda, t, fA, amad, fr, sr, ss] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the Lung (without soft tissue and blood) and WB retention,
 the fecal and urine rate excretion  the day t, in days, after the intake happened" ;

qUInhalationTable::usage = "qUInhalationTable[lambda,{t1, t2, ...}, period, fA, amad, fr, sr, ss] gives the intake retection fraction - IRF- for the WB content, 
the excretion fractions for fec-24h and urine-24-h and the IRF for each compartment 
(note: Sweat, Faeces and Urine represent outside compartements, therefore IRF is the accumulated content since t = 0) and the total in the Respiratory Tract;
lambda is the corresponding caesium isotope decay constant, in day^-1";    

qUInhalationBioassayConst::usage = "qUInhalationBioassayConst[lambda, t1, period, fA, amad, fr, sr, ss] 
For an daily intake 1 of an isotope with a decay constant lambda (in day^-1), during a period T gives 
the lung and WB retention, the fecal and urine fecal rate of excretion the day t";

BioassayReportUranium::usage = 
  "BioassayReportUranium[Injection, Acute, lambda, {t1, t2, ...}], 
BioassayReportUranium[Injection, Constant, lambda, {t1, t2, ...}, period]
BioassayReportUranium[Ingestion, Acute, lambda, {t1, t2, ...}, fA] 
BioassayReportUranium[Ingestion, Constant, lambda, {t1, t2, ...},period, fA] 
BioassayReportUranium[Inhalation, Acute, lambda, {t1, t2, ...}, fA, amad, fr, sr, ss] 
BioassayReportUranium[Inhalation, Constant, lambda, {t1, t2, ...}, 
period, fA, amad, fr, sr, ss] gives the table with lung and WB retention, fecal and urine excretion values" ;

qIInjection::usage =   "qIInjection[lambda,t] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the retention in each compartment the day t, in days, 
after the intake happened; qCsInjection[lambda,t, period] assumed a constant daily intake 1 during a period T in days";
 
qIInjectionBioassay::usage =  "qIInjectionBioassay[lambda, t] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the WB retention, the fecal-24h and urine-24h excretion the day t, in days, 
after the intake happened";

qIInjectionBioassay1::usage = "qIInjectionBioassay1[lambda, t] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1), gives the WB retention, the fecal and urine fecal rate of excretion the day t, in days, 
after the intake happened";

qIInjectionBioassayConst::usage ="qIInjectionBioassayConst[lambda, t, period] For an daily intake 1 of an isotope 
with a decay constant lambda (in day^-1), during a period T gives the WB retention, the fecal and urine fecal rate of excretion the day t";
  
qIInjectionTable::usage = 
     "qIInjectionTable[lambda,  {t1, t2, ...}] For an intake 1 (Bq, mg, ...) of an isotope  with a decay constant lambda (in day^-1)
  gives for the days {t1, t2, ...} the intake retection fraction - IRF- for the WB content, the excretion fractions for fec-24h and urine-24-h and the irf for each compartment 
(note: Sweat, Faeces and Urine represent outside compartements, therefore IRF is the accumulated content since t = 0); 
qCsInjectionTable[lambda, {t1, t2, ...}, period] give the IRF  assuming a daily consntant intake 1 during a periodo T"; 

qIIngestion::usage =   "qIIngestion[decaycte, t, fA] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the retention in each compartment the day t, in days, 
after the intake happened; qCsIngestion[decaycte, t, period, fA] assumed a constant daily intake 1 during a period T in days";
 
qIIngestionBioassay::usage =  "qIIngestionBioassay[lambda, t, fA] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the WB retention, the fecal-24h and urine-24h excretion the day t, in days, 
after the intake happened";

qIIngestionBioassay1::usage = "qIIngestionBioassay1[lambda, t, fA] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1), gives the WB retention, the fecal and urine fecal rate of excretion the day t, in days, 
after the intake happened";

qIIngestionBioassayConst::usage ="qIIngestionBioassayConst[lambda, t, period, fA] For an daily intake 1 of an isotope 
with a decay constant lambda (in day^-1), during a period T gives the WB retention, the fecal and urine fecal rate of excretion the day t";
  
qIIngestionTable::usage = 
     "qIIngestionTable[decaycte, {t1, t2, ...}, fA]  For an intake 1 (Bq, mg, ...) of an isotope  with a decay constant lambda (in day^-1)
gives for the days {t1, t2, ...} the intake retection fraction - IRF- for the WB content, the excretion fractions for fec-24h and 
urine-24-h and the irf for each compartment  (note: Sweat, Faeces and Urine represent outside compartements, therefore IRF is 
the accumulated content since t = 0); 
qCsIngestionTable[[lambda, {t1, t2, ...}, period, fA] gives the IRF  assuming a daily constant intake 1 during a periodo T"; 

qIInhalation::usage = 
  "qIInhalation[lambda, t, fA, amad, fr, sr, ss] For an intake 1 (Bq, mg, ...) of an isotope  
with a decay constant lambda (in day^-1),  gives the retention in each compartment the day t, in days, 
after the intake happened; and qCsInhalation[decaycte, t, period, fA,  idf, fr, sr, ss] assumed a constant 
daily intake 1 during a period T in days";

qIInhalationBioassay::usage = 
  "qIInhalationBioassay[lambda, t, fA, amad, fr, sr, ss]  For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the WB retention, the fecal-24h and urine-24h excretion the day t, in days, 
after the intake happened" ;

qIInhalationBioassay1::usage = 
  "qIInhalationBioassay1[lambda, t, fA, amad, fr, sr, ss] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the WB retention, the fecal and urine rate excretion 
the day t, in days, after the intake happened" ;

qIInhalationTable::usage = "qIInhalationTable[lambda,{t1, t2, ...}, period, fA, amad, fr, sr, ss] gives the intake retection fraction - IRF- for the WB content, 
the excretion fractions for fec-24h and urine-24-h and the IRF for each compartment 
(note: Sweat, Faeces and Urine represent outside compartements, therefore IRF is the accumulated content since t = 0) and the total in the Respiratory Tract;
lambda is the corresponding caesium isotope decay constant, in day^-1";    

qIInhalationBioassayConst::usage = "qIInhalationBioassayConst[lambda, t1, period, fA, amad, fr, sr, ss]
For an daily intake 1 of an isotope with a decay constant lambda (in day^-1), during a period T gives 
the WB retention, the fecal and urine fecal rate of excretion the day t";

BioassayReportIodium::usage = 
  "BioassayReportIodium[Injection, Acute, lambda, {t1, t2, ...}], 
BioassayReportIodium[Injection, Constant, lambda, {t1, t2, ...}, period]
BioassayReportIodium[Ingestion, Acute, lambda, {t1, t2, ...}, fA] 
BioassayReportIodium[Ingestion, Constant, lambda, {t1, t2, ...},period, fA] 
BioassayReportIodium[Inhalation, Acute, lambda, {t1, t2, ...}, fA, amad, fr, sr, ss] 
BioassayReportIodium[Inhalation, Constant, lambda, {t1, t2, ...}, 
period, fA, amad, fr, sr, ss] gives the table with WB retention and fecal and urine excretion values" ;

qCoInjection::usage =   "qCoInjection[lambda,t] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the retention in each compartment the day t, in days, 
after the intake happened; qCsInjection[lambda,t, period] assumed a constant daily intake 1 during a period T in days";
 
qCoInjectionBioassay::usage =  "qCoInjectionBioassay[lambda, t] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the WB retention, the fecal-24h and urine-24h excretion the day t, in days, 
after the intake happened";

qCoInjectionBioassay1::usage = "qCoInjectionBioassay1[lambda, t] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1), gives the WB retention, the fecal and urine fecal rate of excretion the day t, in days, 
after the intake happened";

qCoInjectionBioassayConst::usage ="qCoInjectionBioassayConst[lambda, t, period] For an daily intake 1 of an isotope 
with a decay constant lambda (in day^-1), during a period T gives the WB retention, the fecal and urine fecal rate of excretion the day t";
  
qCoInjectionTable::usage = 
     "qCoInjectionTable[lambda,  {t1, t2, ...}] For an intake 1 (Bq, mg, ...) of an isotope  with a decay constant lambda (in day^-1)
  gives for the days {t1, t2, ...} the intake retection fraction - IRF- for the WB content, the excretion fractions for fec-24h and urine-24-h and the irf for each compartment 
(note: Sweat, Faeces and Urine represent outside compartements, therefore IRF is the accumulated content since t = 0); 
qCsInjectionTable[lambda, {t1, t2, ...}, period] give the IRF  assuming a daily consntant intake 1 during a periodo T"; 

qCoIngestion::usage =   "qCsIngestion[decaycte, t, fA] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the retention in each compartment the day t, in days, 
after the intake happened; qCsIngestion[decaycte, t, period, fA] assumed a constant daily intake 1 during a period T in days";
 
qCoIngestionBioassay::usage =  "qCoIngestionBioassay[lambda, t, fA] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the WB retention, the fecal-24h and urine-24h excretion the day t, in days, 
after the intake happened";

qCoIngestionBioassay1::usage = "qCoIngestionBioassay1[lambda, t, fA] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1), gives the WB retention, the fecal and urine fecal rate of excretion the day t, in days, 
after the intake happened";

qCoIngestionBioassayConst::usage ="qCoIngestionBioassayConst[lambda, t, period, fA] For an daily intake 1 of an isotope 
with a decay constant lambda (in day^-1), during a period T gives the WB retention, the fecal and urine fecal rate of excretion the day t";
  
qCoIngestionTable::usage = 
     "qCoIngestionTable[decaycte, {t1, t2, ...}, fA]  For an intake 1 (Bq, mg, ...) of an isotope  with a decay constant lambda (in day^-1)
gives for the days {t1, t2, ...} the intake retection fraction - IRF- for the WB content, the excretion fractions for fec-24h and 
urine-24-h and the irf for each compartment  (note: Sweat, Faeces and Urine represent outside compartements, therefore IRF is 
the accumulated content since t = 0); 
qCsIngestionTable[[lambda, {t1, t2, ...}, period, fA] gives the IRF  assuming a daily constant intake 1 during a periodo T"; 

qCoInhalation::usage = 
  "qCoInhalation[lambda, t, fA, amad, fr, sr, ss] For an intake 1 (Bq, mg, ...) of an isotope  
with a decay constant lambda (in day^-1),  gives the retention in each compartment the day t, in days, 
after the intake happened; and qCsInhalation[decaycte, t, period, fA,  idf, fr, sr, ss] assumed a constant 
daily intake 1 during a period T in days";

qCoInhalationBioassay::usage = 
  "qCoInhalationBioassay[lambda, t, fA, amad, fr, sr, ss]  For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the WB retention, the fecal-24h and urine-24h excretion the day t, in days, 
after the intake happened" ;

qCoInhalationBioassay1::usage = 
  "qCoInhalationBioassay1[lambda, t, fA, amad, fr, sr, ss] For an intake 1 (Bq, mg, ...) of an isotope 
with a decay constant lambda (in day^-1),  gives the WB retention, the fecal and urine rate excretion 
the day t, in days, after the intake happened" ;

qCoInhalationTable::usage = "qCoInhalationTable[lambda,{t1, t2, ...}, period, fA, amad, fr, sr, ss] gives the intake retection fraction - IRF- for the WB content, 
the excretion fractions for fec-24h and urine-24-h and the IRF for each compartment 
(note: Sweat, Faeces and Urine represent outside compartements, therefore IRF is the accumulated content since t = 0) and the total in the Respiratory Tract;
lambda is the corresponding caesium isotope decay constant, in day^-1";    

qCoInhalationBioassayConst::usage = "qCoInhalationBioassayConst[lambda, t1, period, fA, amad, fr, sr, ss]
For an daily intake 1 of an isotope with a decay constant lambda (in day^-1), during a period T gives 
the WB retention, the fecal and urine fecal rate of excretion the day t";

BioassayReportCobalt::usage = 
  "BioassayReportCobalt[Injection, Acute, lambda, {t1, t2, ...}], 
BioassayReportCobalt[Injection, Constant, lambda, {t1, t2, ...}, period]
BioassayReportCobalt[Ingestion, Acute, lambda, {t1, t2, ...}, fA] 
BioassayReportCobalt[Ingestion, Constant, lambda, {t1, t2, ...},period, fA] 
BioassayReportCobalt[Inhalation, Acute, lambda, {t1, t2, ...}, fA, amad, fr, sr, ss] 
BioassayReportCobalt[Inhalation, Constant, lambda, {t1, t2, ...}, 
period, fA, amad, fr, sr, ss] gives the table with WB retention and fecal and urine excretion values" ;

ResponseReport::usage = "ResponseReport[Element, Injection or Ingestion or Inhalation, Acute or Constant, BioassayReport, lambda, t, period, fAing, for inhation: {fA, fr, sr, ss}, for inhalation: idf ]";


t::usage = 
  "Time since the intake happened or time since the intake started";
x::usage = " xi[t] rention in compartment i as function of t";

RTract::usage = "RespiratoryTract retention";
RLungs::usage = "Lungs retention";
RWB::usage = "Whole Body retention";
RThy::usage = "Thyroid retention";

qFec::usage = "24 h fecal excretion";
qUri::usage = "24 h urine excretion";
kSItoBfA::usage="6*(fA/(1 - fA))";

idfAMADx::usage = 
  "Initial deposition factors at compartments:
{ALV, bb',bbseq, BB', BBseq, ET2', ETseq, ET1, 0, 0, 0, 0, 0, 0}, 
you can write idfAMAD5 or idfAMAD1 to use the defaulf values for AMAD 5 and AMAD 1 . For Vapour and Gas default values write idfVapour and for Vapour of Iodium unspecified write idfVapourI";

BioassayPlot::usage = 
  "BioassayPlot[list_List, Legends] logplot of a list {{a1, a2, a3, a4},...}";

HRTM130Compartmentalnumbers ::usage = 
  "{{ALV,1},{bb',2},{bbseq,3},{BB',4},{BBseq,5},{ET2',6},{ETseq,7},{ET1,8},{LNET,9},{INT,10},{LNTH,11},{Blood,12},{OES,13},{Env,14}}";

CompartmentalnumbersCs={"{Plasma,1}","{RedBloodCells,2}","{SkeletalMuscle,3}","{Liver,4}","{Kidneys,5}","{Spleen,6}","{Pancreas,7}","{Skin,8}","{AdiposeTissue,9}","{Brain,10}",
"{HeartWall,11}","{LungTissue,12}","{RedMarrow,13}","{Cartilage,14}","{TrabecularBoneSurface,15}","{CorticalBoneSurface,16}","{StomachWall,17}","{StContentF,18}","{SmallIntestineWall,19}",
"{SIcontentF,20}","{RightColonWall,21}","{RightColonContent,22}","{LeftColonWall,23}","{RectosigmoidColonWall,24}","{Other1,25}","{Other2,26}","{LeftColonContent,27}","{RectosigmoidColonContent,28}",
"{UrinaryBladderContent,29}","{Faeces,30}","{Urine,31}","{Sweat,32}","{OesophagusSlow,33}","{SIcontentS,34}","{StcontentS,35}","{OesophagusFast,36}","{OralCavityContents,37}"};

CompartmentalnumbersU={"{Plasma,1}","{RBC,2}","{ST0,3}","{ST1,4}","{ST2,5}","{Liver1,6}","{Liver2,7}","{KidneysUrinarypath,8}","{KidneysOtherkidneytissue,9}","{Trabecularbonesurface,10}",
"{Exchtrabecularbonevolume,11}","{Nonexchtrabecularbonevolume,12}","{Corticalbonesurface,13}","{Exchcorticalbonevolume,14}","{Nonexchcorticalbonevolume,15}","{RCcontent,16}","{LCcontent,17}","{RScontent,18}",
"{Urinarybladdercontent,19}","{Faeces,20}","{Urine,21}","{OesophagusSlow,22}","{SIcontent,23}","{Stcontent,24}","{OesophagusFast,25}","{OralCavityContents,26}"};

CompartmentalnumbersCo={"{Blood1,1}","{Blood2,2}","{ST0,3}","{ST1,4}","{ST2,5}","{Liver1,6}","{Liver2,7}","{Kidneys1,8}","{Kidneys2,9}","{Trabecularsurface,10}","{Trabecularvolume,11}","{Corticalsurface,12}",
"{Corticalvolume,13}","{SIcontentf2,14}","{RCcontent,15}","{LCcontent,16}","{RScontent,17}","{Urinarybladdercontent,18}","{Faeces,19}","{Urine,20}","{OesophagusSlow,21}","{SIcontentf1,22}",
"{Stcontent,23}","{OesophagusFast,24}","{OralCavityContents,25}"};

CompartmentalnumbersI = {"{Blood1,1}", "{Blood2,2}", 
    "{SalivaryGlands,3}", "{Thyroid1,4}", "{Thyroid2,5}", 
    "{Liver1,6}", "{Liver2,7}", "{Kidneys1,8}", "{Kidneys2,9}", 
    "{STWall,10}", "{RCContent,11}", "{Other1,12}", "{Other2,13}", 
    "{Other3,14}", "{Other4,15}", "{UBContent,16}", "{Faeces,17}", 
    "{Urine,18}", "{Oesophagus,19}", "{SIContent,20}", 
    "{STContent,21}", "{OralCavity,22}", "{LCContent,23}", 
    "{RSContent,24}", "{OesophagusMS,25}", "{STContentMS,26}", 
    "{SIContentMS,27}", "{OralCavityMS,28}"}; 
    
RBrain::usage = "Brain retention";
RLiver::usage = "Liver retention";
RHeart::usage = "Hear retention"; 


qF18Injection::usage = 
  "qF18Injection[t] For an intake 1 (Bq, mg, ...) of F 18,  gives the 
retention in each compartment the min t, in mins, \nafter the intake
happened"; 
qF18InjectionCte::usage = 
  "qF18InjectionCte[t, period] assumed a constant  intake 1 Bq of 
F18/min during a period T in min. gives the retention in each 
compartment (CompartmentalnumbersF)the day t, in min, 
\nafter the first intake started"; 

qF18InjectionG::usage = 
  "qF18Injection[t] For an intake 1 Bq of F 18,  gives the 
retention in each compartment the min t, in mins, after the intake happened GemetricMean transfer coeffs are used"; 
qF18InjectionCteG::usage = 
  "qF18InjectionCteG[t, period] assumed a constant  intake 1 Bq of 
F18/min during a period T in min. gives the retention in each 
compartment (CompartmentalnumbersF)the day t, in min, after the first intake started. GemetricMean transfer coeffs are used"; 

qF18InjectionTable::usage = 
  "qF18InjectionTable[ {t1, t2, ...}] For an intake 1 Bq of F 18 gives for the mins {t1, t2, ...} the intake retection fraction - IRF- 
for the WB content, the excretion fractions for urine-24-h and the irf for each compartment (note: Urine represent outside compartement, therefore IRF is the accumulated \
content since t = 0); \nqF18InjectionTable[{t1, t2, ...}, period] give the IRF assuming a daily consntant intake 1 during a periodo T"; 

qF18InjectionTableG::usage = 
  "qF18InjectionTable[ {t1, t2, ...}] For an intake 1 Bq of F 18 gives for the mins {t1, t2, ...} the intake retection fraction - IRF- 
for the WB content, the excretion fractions for urine-24-h and the irf for each compartment. GemetricMean transfer coeffs are used. (Note: Urine represent outside compartement, therefore IRF is the accumulated \
content since t = 0); \nqF18InjectionTable[{t1, t2, ...}, period] give the IRF assuming a daily consntant intake 1 during a periodo T"; 


qF18InjectionBioassay::usage = 
  "qF18InjectionBioassay[t] For an intake 1 Bq of F18  gives the WB 
retention, urine-24h excretion the min t, in mins, after the intake 
happened"; 
qF18InjectionBioassay1::usage = 
  "qF18InjectionBioassay1[t] For an intake 1 Bq of F18, gives the WB 
retention and urine rate of excretion the min t, in mins, after the intake happened"; 

BioassayReportF18::usage = "BioassayReportF18[Injection, Acute, {t1, t2, ...}]"; 

CompartmentalnumbersF = {"{Plasma,1}", "{RBCs,2}", "{Urine,3}",    "{WhiteMatterFast,4}", "{WhiteMatterSlow,5}", 
   "{GrayMatterFast,6}", "{GrayMatterSlow,7}", "{OtherTissueFast,8}",   "{OtherTissueSlow,9}", "{LiverFast,10}", "{LiverSlow,11}", "{Myocardium,12}", 
   "{Lungs,13}"}; 



idfAMAD5 = {0.05319, 0.01100794, 0.00002206, 0.01773446, 0.00003554, 0.2576836, 0.0005164, 0.4795, 0, 0, 0, 0, 0, 0}; 

idfAMAD1 = {0.1066, 0.01648696, 0.00003304, 0.01239516, 0.00002484, 0.1315364, 0.0002636, 0.2447, 0, 0, 0, 0, 0, 0}; 

idfAMAD3={0.07712,0.01360274,0.00002726,0.01865262,0.00003738,0.2341308,0.0004692,0.4357, 0, 0, 0, 0, 0, 0};

idfAMAD7={0.03761,0.008745474,0.000017526,0.01563866,0.00003134,0.260977,0.000523,0.4857, 0, 0, 0, 0, 0, 0};

idfAMAD10={0.02368,0.00626245,0.00001255,0.0126247,0.0000253,0.2552884,0.0005116,0.4751, 0, 0, 0, 0, 0, 0};

idfVapour= {0.5,0.1996, 0.0004, 0.0998, 0.0002, 0.1996, 0.0004, 0,0, 0, 0, 0, 0, 0};

idfVapourI = {0,0, 0, 0.499, 0.001, 0.499, 0.001, 0,0, 0, 0, 0, 0, 0};


Begin["`Private`"]

transfercoeffhrtm = {{1, 2, 0.002}, {1, 10, 0.001}, {2, 4, 0.2}, {3, 11, 0.001}, 
{4, 6, 10}, {5, 11, 0.001}, {6, 13, 100}, {7, 9, 0.001}, {8, 14, 0.6}, {8, 6, 1.5}, 
{10, 11, 0.00003}, {1, 12, ks}, {2, 12, ks}, {3, 12, ks}, {4, 12, ks}, {5, 12, ks}, 
{6, 12, ks}, {7, 12, ks}, {9, 12, ks}, {10, 12, ks}, {11, 12, ks}}; 

HRTM130[idf_,fr1_, ks1_,  lambda_: 0] := Module[{idf1},idf1 = 
  MapAt[fr1*#1 & , idf, 1 ;; 8];
   Chop[ExpandAll[
   AcuteInput1[
    CompartMatrix[14, transfercoeffhrtm, lambda] /. ks -> ks1, 
         idf1, t, x]]]];

qTRRetention[t1_, idf_,fr_,  sr_, ss_, lambda_: 0] := 
   {"RapidDissolutionSubsystem" -> Most[HRTM130[idf, fr, sr,  lambda]], 
       "SlowDissolutionSubsystem" -> 
    Most[HRTM130[idf, 1 - fr, ss,  lambda]]} /. t -> t1;

RTRetention[idf_,fr_, sr_, ss_, lambda_: 0] := 
   Module[{hrtmRD, hrtmSD, RT, xRT, xRD, xSD, xBlood, xOES}, 
        {hrtmRD, hrtmSD} = {HRTM130[idf, fr, sr, lambda ], 
     HRTM130[idf, 1 - fr, ss, lambda]}; 
      xRT =  Table[Subscript[x, i][t], {i, 1, 11}];
    RT = Chop[Total[Evaluate[xRT /. hrtmRD]] + 
           Total[Evaluate[xRT /. hrtmSD]]]; 
         {xRD, xSD} = {{Subscript[x, 12][t], Subscript[x, 13][t]} /. hrtmRD, 
               {Subscript[x, 12][t], Subscript[x, 13][t]} /. hrtmSD}; 
         {xBlood, xOES} = xRD + xSD; {RT, D[xBlood, t], D[xOES, t]}];
         


compartmentnamesCs = ToString /@ ToExpression[CompartmentalnumbersCs][[All,1]]; 
compartmentnamesU = ToString /@ ToExpression[CompartmentalnumbersU][[All,1]]; 
compartmentnamesCo = ToString /@ ToExpression[CompartmentalnumbersCo][[All,1]]; 
compartmentnamesI = ToString /@ ToExpression[CompartmentalnumbersI][[All,1]]; 
compartmentnamesIinj = Drop[compartmentnamesI, -4]; 
compartmentnamesIinh = ToString /@ ToExpression[Drop[CompartmentalnumbersI, -1]][[All,1]]; 
compartmentnamesF = ToString /@ ToExpression[CompartmentalnumbersF][[All,1]]; 


  transfercoeffCs = {{1, 2, 1.8}, {1, 3, 30}, {1, 4, 19.5}, {1, 5, 67.1}, {1, 6, 5.3}, 
  {1, 7, 1.77},  {1, 8, 4.42}, {1, 9, 8.83}, {1, 10, 0.424}, {1, 11, 14.1}, 
  {1, 12, 4.42}, {1, 13, 5.3}, {1, 14, 3}, {1, 15, 1.59}, {1, 16, 1.06}, {1, 17, 3.53}, 
  {1, 18, 4.52}, {1, 19, 35.3}, {1, 20, 1.05}, {1, 21, 5.65}, {1, 22, 0.02}, 
  {1, 23, 5.65}, {1, 24, 2.83}, {1, 25, 9.71}, {1, 26, 0.00353}, {2, 1, 0.257}, 
  {3, 1, 0.0751}, {4, 1, 2.14}, {4, 20, 0.113}, {5, 29, 1.68}, {5, 1, 31.9}, 
  {6, 1, 5.03}, {6, 4, 0.265}, {7, 1, 1.68}, {7, 4, 0.0883}, {8, 1, 0.867}, 
  {8, 32, 0.0159}, {9, 1, 1.77}, {10, 1, 0.0848}, {11, 1, 8.07}, {12, 1, 1.47}, 
  {13, 1, 0.706}, {14, 1, 0.2}, {15, 1, 0.212}, {16, 1, 0.212}, {17, 1, 4.16}, 
  {17, 4, 0.219}, {17, 18, 0.21}, {19, 1, 9.87}, {19, 4, 0.519}, {19, 20, 0.21}, 
  {21, 1, 6.86}, {21, 4, 0.361}, {21, 22, 0.21}, {23, 1, 6.86}, {23, 4, 0.361}, 
  {23, 27, 0.21}, {24, 1, 6.86}, {24, 4, 0.361}, {24, 28, 0.21}, {25, 1, 0.762}, 
  {26, 1, 0.00141}, {18, 20, 20.57}, {20, 22, 6}, {22, 27, 2}, {27, 28, 2.01}, 
  {28, 30, 2.02}, {29, 31, 12}, {20, 1, 594}, {34, 1, kSItoBfA}, 
  {34, 22, 6}, {35, 34, 20.57}, {33, 35, 2160}, {36, 35, 12343}, {37, 36, 6480}, 
  {37, 33, 720}}; 

transfercoeffU = {{1, 3, 10.5}, {1, 2, 0.245}, {1, 19, 15.43}, {1, 8, 2.94}, {1, 9, 0.0122}, {1, 16, 0.122}, {1, 6, 0.367}, 
    {1, 4, 1.63}, {1, 5, 0.0735}, {1, 10, 2.04}, {1, 13, 1.63}, {3, 1, 8.32}, {2, 1, 0.347}, {8, 19, 0.099}, {9, 1, 0.00038}, 
    {6, 1, 0.092}, {6, 7, 0.00693}, {7, 1, 0.00019}, {4, 1, 0.0347}, {5, 1, 0.000019}, {10, 1, 0.0693}, {10, 11, 0.0693}, 
    {13, 1, 0.0693}, {13, 14, 0.0693}, {12, 1, 0.000493}, {15, 1, 0.0000821}, {11, 10, 0.0173}, {11, 12, 0.00578}, {14, 13, 0.0173}, 
    {14, 15, 0.00578}, {16, 17, 2}, {17, 18, 2.01}, {18, 20, 2.02}, {19, 21, 12}, {26, 25, 6480}, {26, 22, 720}, {25, 24, 12343}, 
    {22, 24, 2160}, {24, 23, 20.57}, {23, 1, kSItoBfA}, {23, 16, 6}}; 
    
transfercoeffCobalt = {{1, 6, 70}, {1, 18, 60}, {1, 15, 4}, {1, 3, 18}, {1, 4, 10}, {1, 5, 4}, {1, 12, 6}, {1, 10, 6}, {1, 8, 9}, 
    {1, 9, 1}, {1, 2, 12}, {2, 1, 0.693}, {6, 14, 0.0924}, {6, 1, 0.347}, {6, 7, 0.0231}, {7, 1, 0.0019}, {3, 1, 0.099}, 
    {4, 1, 0.0139}, {5, 1, 0.00095}, {12, 1, 0.0842}, {12, 13, 0.0149}, {10, 1, 0.0842}, {10, 11, 0.0149}, {13, 1, 0.0000821}, 
    {11, 1, 0.000493}, {8, 18, 0.462}, {9, 1, 0.0019}, {14, 1, 0.6666667}, {14, 15, 6}, {15, 16, 2}, {16, 17, 2.01}, {17, 19, 2.02}, 
    {18, 20, 12}, {21, 23, 2160}, {23, 22, 20.57}, {22, 1, kSItoBfA}, {22, 15, 6}, {24, 23, 12343}, {25, 24, 6480}, 
    {25, 21, 720}}; 

transfercoeffI = {{1, 4, 7.26}, {1, 16, 11.84}, {1, 3, 5.16}, 
    {1, 10, 8.6}, {1, 12, 600}, {1, 8, 25}, {1, 6, 15}, {3, 22, 50}, 
    {10, 21, 50}, {4, 5, 95}, {4, 1, 36}, {5, 2, 0.0077}, {5, 1, 0}, 
    {12, 1, 330}, {12, 13, 35}, {13, 12, 56}, {8, 1, 100}, 
    {6, 1, 100}, {2, 14, 15}, {14, 2, 21}, {14, 15, 1.2}, 
    {15, 14, 0.62}, {15, 1, 0.14}, {2, 9, 3.6}, {9, 2, 21}, 
    {9, 1, 0.14}, {2, 7, 21}, {7, 2, 21}, {7, 1, 0.14}, 
    {7, 11, 0.08}, {22, 19, 7200}, {19, 21, 2160}, {21, 20, 20.57}, 
    {20, 11, 6}, {20, 1, 594}, {16, 18, 12}, {11, 23, 2}, 
    {23, 24, 2.01}, {24, 17, 2.02}, {25, 26, 2160}, {26, 27, 20.57}, 
    {27, 1, kSItoBfA}, {27, 11, 6}, {28, 25, 7200}}; 



transfercoeffIinj=Drop[transfercoeffI,-5];

transfercoeffIinh = Drop[transfercoeffI, -1]; 


daysirf= Sort[Flatten[{14, 15, 45, 120, 180, 365, Range[0, 9], Range[10, 100, 10], 
        Range[200, 1000, 100], Range[2000, 10000, 1000]}]];

BioassayPlot[list_List, legend_] := 
 Module[{a, b, c, d}, {a, b, c, d} = Transpose[Rest[list]]; 
  ListLogPlot[{Transpose[{a, b}], Transpose[{a, c}], 
    Transpose[{a, d}]}, Joined -> True, 
   PlotLegends -> legend]];

(* Caesium*)

(*Caesium Injection*)

qCsInjection[decaycte_,t_] := 
 AcuteInput1[CompartMatrix[32, Drop[transfercoeffCs, -7] , decaycte], PadRight[{1}, 32], t, x]; 

qCsInjection[decaycte_, t_, period_] := Module[{tau},
  (qConstant[1, {#1, tau}, t, period] & ) /@ Evaluate[Table[Subscript[x, i][tau], {i, 1, 29}] /. 
   Chop[qCsInjection[decaycte, tau]]]]

(* La funcion de abajo da el WB retention y la excreci\[OAcute]n acumulada en 24 h*)
  
qCsInjectionBioassay[decaycte_, t1_]:= Module[{t, wb, fec, uri}, 
       {wb[t_], fec[t_], uri[t_]} = {Total[Table[Subscript[x, i][t], {i, 1, 29}]], Subscript[x, 30][t], 
                Subscript[x, 31][t]} /. qCsInjection[0, t]; Thread[{RWB[t1], qFec[t1], qUri[t1]} -> 
            {wb[t1], fec[t1] - fec[t1 - 1], uri[t1] - uri[t1 - 1]}*Exp[(-decaycte)*t1]]]; 
            
(* La funcion de abajo da la excreci\[OAcute]n instantanea, es una funci\[OAcute]n auxiliar lara poder calcular la integral*)  
          
qCsInjectionBioassay1[decaycte_, t1_]:= Module[{t, wb, fec, uri}, 
       {wb[t_], fec[t_], uri[t_]} = {Total[Table[Subscript[x, i][t], {i, 1, 29}]], Subscript[x, 28][t], 
                Subscript[x, 29][t]} /. qCsInjection[0, t]; Thread[{RWB[t1], qFec[t1], qUri[t1]} -> 
            ExpandAll[{wb[t1], 2*fec[t1] , 12*uri[t1]}*Exp[(-decaycte)*t1]]]]; 

qCsInjectionBioassayConst[decaycte_, t1_, period_] := 
   Module[{t, tau, wb1, fec1, uri1}, 
    {wb1[t_], fec1[t_], uri1[t_]} = (qConstant[1, {#1, tau}, t, period] & ) /@ 
       Evaluate[ExpandAll[{RWB[tau], qFec[tau], qUri[tau]} /. 
          qCsInjectionBioassay1[decaycte, tau]]]; 
     Thread[{RWB[t1], qFec[t1], qUri[t1]} -> {wb1[t1], fec1[t1], uri1[t1]}]]; 

qCsInjection1[decaycte_,t_]:=Flatten[{RWB[t],If[t<1,0,qFec[t]],If[t<1,0,qUri[t]],
Table[Subscript[x,i][t],{i,1,32}]}]/.Flatten[{qCsInjection[decaycte,t],qCsInjectionBioassay[decaycte,t]}];

qCsInjectionTable[decaycte_, t2_]:=Prepend[Chop[(Prepend[qCsInjection1[decaycte, #1],#1]&)/@Sort[Flatten[Append[Drop[daysirf,1], t2]]]],
Flatten[{"Days",{"WB","FEC24h","URI24h"},Drop[compartmentnamesCs,-5]}]];

qCsInjectionTable[decaycte_, t2_, period_]:=Prepend[Chop[(Prepend[qCsInjection[decaycte, #, period] ,
#1]&)/@Sort[Flatten[Append[Drop[daysirf,1], t2]]]], Flatten[{"Days",Drop[compartmentnamesCs,-8]}]];
    

BioassayReportCaesium["Injection", "Acute", decaycte_, t2_]:= 
    Module[{csreport, bio}, 
          bio = {RWB[t], qFec[t], qUri[t]} /. qCsInjectionBioassay[decaycte, t]; 
  csreport[t1_] = bio /. t -> t1;
        Prepend[(Prepend[csreport[#1], #1] & ) /@ Sort[Flatten[Append[Drop[daysirf,1], t2]]], 
           {"days", "Wb", "Fec24h", "Urine24h"}]];

BioassayReportCaesium["Injection", "Constant", decaycte_, t2_,period_]:= 
   Module[{csreport, bio}, bio = {RWB[t], qFec[t], qUri[t]} /. 
       qCsInjectionBioassayConst[decaycte, t, period]; csreport[t1_] = bio /. t -> t1; 
     Prepend[(Prepend[csreport[#1], #1] & ) /@Sort[Flatten[Append[Drop[daysirf,1], t2]]], 
      {"days", "Wb", "Fec24h", "Urine24h"}]];     

ResponseReport["Caesium","Injection", "Acute", "ResponseFunction", decaycte_,t2_, ___]:=
qCsInjectionBioassay[decaycte, t2]//ExpandAll;

ResponseReport["Caesium","Injection", "Constant", "ResponseFunction", decaycte_, t2_, period_,___]:=
qCsInjectionBioassayConst[decaycte, t2, period];    

ResponseReport["Caesium","Injection", "Acute", "BioassayReport", decaycte_, t2_,___]:=
BioassayReportCaesium["Injection", "Acute", decaycte, t2];

ResponseReport["Caesium","Injection", "Constant", "BioassayReport", decaycte_, t2_, period_,___]:=
BioassayReportCaesium["Injection", "Constant", decaycte, t2, period];

ResponseReport["Caesium","Injection", "Acute", "CompartmentContents", decaycte_, t2_,___]:=
qCsInjectionTable[decaycte, t2];

ResponseReport["Caesium","Injection", "Constant",  "CompartmentContents", decaycte_, t2_, period_,___]:=
qCsInjectionTable[decaycte, t2, period];
  
ResponseReport["Caesium","Injection", "Acute", "GraphicsReport", decaycte_, tminmax_,___]:=
LogPlot[Evaluate[ExpandAll[{RWB[t1], qFec[t1], qUri[t1]}/.qCsInjectionBioassay1[decaycte, t1]]], 
Evaluate[Flatten[{t1, MinMax[tminmax]}]],PlotRange->All, PlotLegends -> {"RWB", "qFec", "qUri"}];

ResponseReport["Caesium","Injection", "Constant", "GraphicsReport", decaycte_, tminmax_,period_,___]:=
LogPlot[Evaluate[ExpandAll[{RWB[t1], qFec[t1], qUri[t1]}/.qCsInjectionBioassayConst[decaycte, t1, period]]], 
Evaluate[Flatten[{t1, MinMax[tminmax]}]],PlotRange->All, PlotLegends -> {"RWB", "qFec", "qUri"}];

(*Caesium Ingestion*)

qCsIngestion[decaycte_, t_, fA_] := 
  Chop[AcuteInput1[CompartMatrix[37, transfercoeffCs /. 
      kSItoBfA -> 6*(fA/(1 - fA)), decaycte], PadLeft[{1}, 37], t, x]];

qCsIngestion[decaycte_, t_, period_, fA_] := Module[{tau},
  (qConstant[1, {#1, tau}, t, period] & ) /@ Evaluate[Table[Subscript[x, i][tau], {i, 1, 37}] /. 
   Chop[qCsIngestion[decaycte, tau, fA]]]]

qCsIngestionBioassay[decaycte_, t1_, fA_] := Module[{t, wb, fec, uri}, 
       {wb[t_], fec[t_], uri[t_]} = 
          {Total[Flatten[{Table[Subscript[x, i][t], {i, 1, 29}], 
         Subscript[x, 33][t], Subscript[x, 34][t], 
         Subscript[x, 35][t], Subscript[x, 36][t]}]], Subscript[x, 30][t], 
         Subscript[x, 31][t]} /. qCsIngestion[0, t, fA]; Thread[{RWB[t1], qFec[t1], qUri[t1]} -> 
            {wb[t1], fec[t1] - fec[t1 - 1], uri[t1] - uri[t1 - 1]}*Exp[(-decaycte)*t1]]]; 
     
qCsIngestionBioassay1[decaycte_, t1_, fA_]:= Module[{t, wb, fec, uri}, 
       {wb[t_], fec[t_], uri[t_]} = {Total[Flatten[{Table[Subscript[x, i][t], {i, 1, 29}], 
         Subscript[x, 33][t], Subscript[x, 34][t], 
         Subscript[x, 35][t], Subscript[x, 36][t]}]], Subscript[x, 22][t], 
         Subscript[x, 29][t]} /. qCsIngestion[0, t, fA]; Thread[{RWB[t1], qFec[t1], qUri[t1]} -> 
            ExpandAll[{wb[t1], 2*fec[t1] , 12*uri[t1]}*Exp[(-decaycte)*t1]]]];

qCsIngestion1[decaycte_,t_,fA_]:=Flatten[{RWB[t],If[t<1,0,qFec[t]],If[t<1,0,qUri[t]],
Table[Subscript[x,i][t],{i,1,37}]}]/.Flatten[{qCsIngestion[decaycte, t,fA],
  qCsIngestionBioassay[decaycte, t, fA]}];

qCsIngestionTable[decaycte_, t2_,fA_]:= 
Prepend[(Prepend[qCsIngestion1[decaycte, #1,fA],#1]&)/@Sort[Flatten[Append[Drop[daysirf,1], t2]]],
Flatten[{"Days",{"WB","FEC24h","URI24h"},compartmentnamesCs}]];

qCsIngestionTable[decaycte_, t2_, period_, fA_]:=Prepend[Chop[(Prepend[qCsIngestion[decaycte, #, period, fA] ,
#1]&)/@Sort[Flatten[Append[Drop[daysirf,1], t2]]]], Flatten[{"Days", compartmentnamesCs}]];

qCsIngestionBioassayConst[decaycte_, t1_, period_, fA_] := 
   Module[{t, tau, wb1, fec1, uri1}, 
    {wb1[t_], fec1[t_], uri1[t_]} = (qConstant[1, {#1, tau}, t, period] & ) /@ 
       Evaluate[ExpandAll[{RWB[tau], qFec[tau], qUri[tau]} /. 
          qCsIngestionBioassay1[decaycte, tau, fA]]]; 
     Thread[{RWB[t1], qFec[t1], qUri[t1]} -> {wb1[t1], fec1[t1], uri1[t1]}]];  

BioassayReportCaesium["Ingestion", "Acute", decaycte_, t2_, fA_] :=  
 Module[{ csreport, bio, t, t1}, 
    bio = {RWB[t], qFec[t], qUri[t]} /. 
    qCsIngestionBioassay[decaycte, t, fA]; 
        csreport[t1_] = bio /. t -> t1; 
  Prepend[(Prepend[csreport[#1], #1] & )/@Sort[Flatten[Append[Drop[daysirf,1], t2]]], 
           {"days", "Wb", "Fec24h", "Urine24h"}]];

BioassayReportCaesium["Ingestion", "Constant", decaycte_, t2_,period_, fA_] := 
   Module[{csreport, bio}, bio = {RWB[t], qFec[t], qUri[t]} /. 
       qCsIngestionBioassayConst[decaycte, t, period, fA]; 
     csreport[t1_] = bio /. t -> t1; Prepend[(Prepend[csreport[#1], #1] & ) /@ 
      Sort[Flatten[Append[Drop[daysirf,1], t2]]], {"days", "Wb", "Fec24h", "Urine24h"}]]; 

ResponseReport["Caesium","Ingestion", "Acute", "ResponseFunction", decaycte_, t2_, period_, fA_,___]:=
qCsIngestionBioassay[decaycte, t2, fA]//Chop//ExpandAll;

ResponseReport["Caesium","Ingestion", "Constant", "ResponseFunction", decaycte_, t2_, period_, fA_,___]:=
qCsIngestionBioassayConst[decaycte, t2, period, fA] ;  

ResponseReport["Caesium","Ingestion", "Acute", "BioassayReport", decaycte_, t2_,  period_,fA_,___]:=
BioassayReportCaesium["Ingestion", "Acute", decaycte, t2, fA];

ResponseReport["Caesium","Ingestion", "Constant", "BioassayReport", decaycte_, t2_, period_,fA_,___]:=
BioassayReportCaesium["Ingestion", "Constant", decaycte, t2, period, fA];

ResponseReport["Caesium","Ingestion", "Acute", "CompartmentContents", decaycte_, t2_, period_, fA_,___]:=
qCsIngestionTable[decaycte, t2, fA];

ResponseReport["Caesium","Ingestion", "Constant","CompartmentContents", decaycte_, t2_, period_, fA_,___]:=
qCsIngestionTable[decaycte, t2, period, fA];
  
ResponseReport["Caesium","Ingestion", "Acute", "GraphicsReport", decaycte_, tminmax_,  period_, fA_,___]:=
LogPlot[Evaluate[ExpandAll[{RWB[t1], qFec[t1], qUri[t1]}/.qCsIngestionBioassay1[decaycte, t1, fA]]], 
Evaluate[Flatten[{t1, MinMax[tminmax]}]],PlotRange->All, PlotLegends -> {"RWB", "qFec", "qUri"}];

ResponseReport["Caesium","Ingestion", "Constant", "GraphicsReport", decaycte_, tminmax_,period_, fA_,___]:=
LogPlot[Evaluate[ExpandAll[{RWB[t1], qFec[t1], qUri[t1]}/.qCsIngestionBioassayConst[decaycte, t1, period, fA]]], 
Evaluate[Flatten[{t1, MinMax[tminmax]}]],PlotRange->All, PlotLegends -> {"RWB", "qFec", "qUri"}];     

(*Caesium inhalation*)

(*se supone que la trasferencia desde ET'2  va a {StcontentS,35}, esto es: 
{blood,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,oes}, 
si se quiere hacer en el Esofago habria que poner 
{blood,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,oes,0,0} *)

qCsInhalation[decaycte_, t1_, fA_, idf_, fr_, sr_, ss_]:= 
     Module[{rt, blood, oes, initialconditions, b1Cs, 
    transfercoeffCs1,  transfercoeffCs2,xNumbers}, 
       {rt, blood, oes} = RTRetention[idf, fr, sr, ss]; 
   initialconditions = PadRight[{0}, 35]; 
        b1Cs = {blood, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
     0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, oes}; 
    transfercoeffCs1= Drop[transfercoeffCs, -3];
   transfercoeffCs2 = transfercoeffCs1/. kSItoBfA -> 6*(fA/(1 - fA)); 
    xNumbers = Flatten[{Table[Subscript[x, i][t1], {i, 1, 35}], RTract[t1]}]; 
        Thread[
    xNumbers -> 
     Evaluate[xNumbers /. SystemDSolve[CompartMatrix[35, transfercoeffCs2], 
     initialconditions, b1Cs, t, t1, x] /. RTract[t1] -> Evaluate[rt /. t -> t1]]*Exp[(-decaycte)*t1]]]; 

qCsInhalation[decaycte_, t_, period_, fA_,  idf_, fr_, sr_, ss_] := Module[{tau},
  (qConstant[1, {#1, tau}, t, period] & ) /@ Evaluate[Flatten[{Table[Subscript[x, i][tau], {i, 1, 35}], 
  RTract[tau]}] /. Chop[qCsInhalation[decaycte, tau, fA, idf, fr, sr, ss]]]]

qCsInhalationBioassay[decaycte_, t1_, fA_, idf_, fr_, sr_, ss_] := 
   Module[{rt, blood, oes, initialconditions, b1Cs, transfercoeffCs1, sol2, 
     csRetention, fecCs, uriCs, qWBcs, fecCs1, uriCs1, qWBcs1}, 
    ({rt, blood, oes} = RTRetention[idf,fr, sr, ss]; initialconditions = 
       PadRight[{0}, 35]; b1Cs = {blood, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, oes}; 
      transfercoeffCs1 = Drop[transfercoeffCs, -3] /.kSItoBfA ->  6*(fA/(1 - fA));
       sol2 = SystemDSolve[CompartMatrix[35, 
          transfercoeffCs1], initialconditions, b1Cs, t, t, x]; 
      csRetention = Total[Evaluate[Flatten[{Table[Subscript[x, i][t], 
             {i, 1, 29}], Table[Subscript[x, i][t], {i, 33, 35, 1}]}] /. sol2]]; 
      {fecCs, uriCs} = {Subscript[x, 30][t], Subscript[x, 31][t]} /. sol2; 
      qWBcs = csRetention + rt; qWBcs1 = qWBcs /. t -> t1; 
      fecCs1 = Evaluate[fecCs /. t -> t1] - Evaluate[fecCs /. t -> t1 - 1]; 
      uriCs1 = Evaluate[uriCs /. t -> t1] - Evaluate[uriCs /. t -> t1 - 1]; ); 
     Thread[{RWB[t1], qFec[t1], qUri[t1]} -> 
      ExpandAll[{qWBcs1, fecCs1, uriCs1}*Exp[(-decaycte)*t1]]]]; 

qCsInhalationBioassay1[decaycte_, t1_, fA_, idf_, fr_, sr_, ss_] := 
   Module[{rt, blood, oes, initialconditions, b1Cs, transfercoeffCs1, sol2, 
     csRetention, fecCs, uriCs, qWBcs, fecCs1, uriCs1, qWBcs1}, 
    ({rt, blood, oes} = RTRetention[idf,fr, sr, ss]; initialconditions = 
       PadRight[{0}, 35]; b1Cs = {blood, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0, oes}; 
      transfercoeffCs1 = Drop[transfercoeffCs, -3] /.kSItoBfA ->  6*(fA/(1 - fA));
       sol2 = SystemDSolve[CompartMatrix[35, 
          transfercoeffCs1], initialconditions, b1Cs, t, t, x]; 
      csRetention = Total[Evaluate[Flatten[{Table[Subscript[x, i][t], 
             {i, 1, 29}], Table[Subscript[x, i][t], {i, 33, 35, 1}]}] /. sol2]]; 
      {fecCs, uriCs} = {Subscript[x, 28][t], Subscript[x, 29][t]} /. sol2; 
      qWBcs = csRetention + rt); 
     Thread[{RWB[t], qFec[t], qUri[t]} -> 
      ExpandAll[{qWBcs, 2*fecCs, 12*uriCs}*Exp[(-decaycte)*t]]]]; 

BioassayReportCaesium["Inhalation", "Acute", decaycte_, t2_, fA_, idf_, fr_, sr_, ss_] :=  
 Module[{ csreport, bio, t, t1}, 
    bio = {RWB[t], qFec[t], qUri[t]} /. 
    qCsInhalationBioassay[decaycte, t, fA, idf, fr, sr, ss]; 
        csreport[t1_] = bio /. t -> t1; 
  Prepend[(Prepend[csreport[#1], #1] & )/@Sort[Flatten[Append[Drop[daysirf,1], t2]]], 
           {"days", "Wb", "Fec24h", "Urine24h"}]];

qCsInhalationTable[decaycte_,t2_,  fA_, idf_, fr_, sr_, ss_]:=Module[{solUS},
solUS[t_]=Evaluate[Flatten[{Table[Subscript[x,i][t],{i,1,35}],
RTract[t]}]/.qCsInhalation[decaycte, t, fA, idf, fr, sr, ss]];
Prepend[Chop[(Prepend[solUS[#],#1]&)/@Sort[Flatten[Append[Drop[daysirf,1], t2]]]],
Flatten[{"Day",Drop[compartmentnamesCs,-2],"RT"}]]];

qCsInhalationBioassayConst[decaycte_, t1_, period_, fA_, idf_, fr_, sr_, ss_] := 
   Module[{t, tau, wb, fec, uri, wb1, fec1, uri1}, 
    {wb[t_], fec[t_], uri[t_]} = 
      {Total[Append[Table[Subscript[x, i][t], {i, Join[Range[1, 29], 
             Range[32, 35]]}], RTract[t]]], Subscript[x, 28][t], 
        Subscript[x, 29][t]} /. qCsInhalation[0, t, fA, idf, fr, sr, ss]; 
     {wb1[t_], fec1[t_], uri1[t_]} = (qConstant[1, {#1, tau}, t, period] & ) /@ 
       Evaluate[ExpandAll[{wb[tau]*Exp[(-decaycte)*tau], 
          2*fec[tau]*Exp[(-decaycte)*tau], 12*uri[tau]*Exp[(-decaycte)*tau]}]]; 
     Thread[{RWB[t1], qFec[t1], qUri[t1]} -> {wb1[t1], fec1[t1], uri1[t1]}]]; 

qCsInhalationTable[decaycte_,t2_, period_, fA_, idf_, fr_, sr_, ss_]:=
Prepend[Chop[(Prepend[qCsInhalation[decaycte, #, period, fA, idf, fr, sr, ss] ,
#1]&)/@Evaluate[Sort[Flatten[Append[Range[Round[period/10], period, Round[period/10]], t2]]]]],
Flatten[{"Day",Drop[compartmentnamesCs,-2],"RT"}]];

BioassayReportCaesium["Inhalation", "Constant", decaycte_, t2_, period_, fA_, 
    idf_, fr_, sr_, ss_] := Module[{csreport, bio}, 
    bio = {RWB[t], qFec[t], qUri[t]} /. qCsInhalationBioassayConst[decaycte, t, 
        period, fA, idf, fr, sr, ss]; csreport[t1_] = bio /. t -> t1; 
     Prepend[(Prepend[csreport[#1], #1] & ) /@ 
       Sort[Flatten[Append[Drop[daysirf, 1], t2]]], {"days", "Wb", "Fec24h", 
       "Urine24h"}]];
       
ResponseReport["Caesium","Inhalation", "Acute", "ResponseFunction", decaycte_, t2_,period_, fAing_,{fA_, fr_, sr_, ss_}, idf_]:=
qCsInhalationBioassay[decaycte, t2, fA, idf, fr, sr, ss];

ResponseReport["Caesium","Inhalation", "Constant", "ResponseFunction", decaycte_, t2_,period_, fAing_,{fA_, fr_, sr_, ss_}, idf_]:=
qCsInhalationBioassayConst[decaycte, t2, period, fA, idf, fr, sr, ss]; 

ResponseReport["Caesium","Inhalation", "Acute", "BioassayReport", decaycte_, t2_,period_, fAing_,{fA_, fr_, sr_, ss_}, idf_]:=
BioassayReportCaesium["Inhalation", "Acute", decaycte, t2, fA, idf, fr, sr, ss];

ResponseReport["Caesium","Inhalation", "Constant", "BioassayReport", decaycte_, t2_, period_, fAing_,{fA_, fr_, sr_, ss_}, idf_]:=
BioassayReportCaesium["Inhalation", "Constant", decaycte, t2, period, fA, idf, fr, sr, ss];

ResponseReport["Caesium","Inhalation", "Acute", "CompartmentContents", decaycte_, t2_, period_, fAing_,{fA_, fr_, sr_, ss_}, idf_]:=
qCsInhalationTable[decaycte, t2, fA, idf, fr, sr, ss];

ResponseReport["Caesium","Inhalation", "Constant",  "CompartmentContents", decaycte_, t2_, period_, fAing_, {fA_, fr_, sr_, ss_}, idf_]:=
qCsInhalationTable[decaycte, t2, period, fA, idf, fr, sr, ss];
  
ResponseReport["Caesium","Inhalation", "Acute", "GraphicsReport", decaycte_, tminmax_,period_, fAing_,{fA_, fr_, sr_, ss_}, idf_]:=
LogPlot[Evaluate[ExpandAll[{RWB[t1], qFec[t1], qUri[t1]}/.qCsInhalationBioassay[decaycte, t1, fA, idf, fr, sr, ss]]], 
Evaluate[Flatten[{t1, MinMax[tminmax]}]],PlotRange->All, PlotLegends -> {"RWB", "qFec", "qUri"}];

ResponseReport["Caesium","Inhalation", "Constant", "GraphicsReport", decaycte_, tminmax_,period_, fAing_, {fA_, fr_, sr_, ss_}, idf_]:=
LogPlot[Evaluate[ExpandAll[{RWB[t1], qFec[t1], qUri[t1]}/.qCsInhalationBioassayConst[decaycte, t1, period, fA, idf, fr, sr, ss]]], 
Evaluate[Flatten[{t1, MinMax[tminmax]}]],PlotRange->All, PlotLegends -> {"RWB", "qFec", "qUri"}]; 

(*Uranium*)

(*Uranium Injection*)

qUInjection[lambda_,t_] := 
 AcuteInput1[CompartMatrix[21, Drop[transfercoeffU,-7], lambda], PadRight[{1}, 21], t, x];

qUInjectionBioassay[lambda_,t1_] := Module[{t, wb, fec, uri}, 
       {wb[t_], fec[t_], uri[t_]} = {Total[Table[Subscript[x, i][t], {i, 1, 19}]], Subscript[x, 20][t], 
                Subscript[x, 21][t]} /. qUInjection[0, t]; Thread[{RWB[t1], qFec[t1], qUri[t1]} -> 
            {wb[t1], fec[t1] - fec[t1 - 1], uri[t1] - uri[t1 - 1]}*Exp[(-lambda)*t1]]]; 

qUInjection1[lambda_,t_] := Flatten[{RWB[t], If[t < 1, 0, qFec[t]], If[t < 1, 0, 
qUri[t]], Table[Subscript[x, i][t], {i, 1, 21}]}] /. Flatten[{qUInjection[lambda, t], qUInjectionBioassay[lambda, t]}]; 

qUInjectionTable[decaycte_, t2_]:=Prepend[Chop[(Prepend[qUInjection1[decaycte, #1],#1]&)/@Sort[Flatten[Append[Drop[daysirf,1], t2]]]],
Flatten[{"Days",{"WB","FEC24h","URI24h"},Drop[compartmentnamesU,-5]}]];

BioassayReportUranium["Injection", "Acute", decaycte_, t2_]:= 
    Module[{csreport, bio}, 
          bio = {RWB[t], qFec[t], qUri[t]} /. qUInjectionBioassay[decaycte, t]; 
  csreport[t1_] = bio /. t -> t1;
        Prepend[(Prepend[csreport[#1], #1] & ) /@ Sort[Flatten[Append[Drop[daysirf,1], t2]]], 
           {"days", "Wb", "Fec24h", "Urine24h"}]]; 

qUInjectionBioassay1[decaycte_, t1_] := Module[{t, wb, fec, uri}, 
    {wb[t_], fec[t_], uri[t_]} = {Total[Table[Subscript[x, i][t], {i, 1, 19}]], 
        Subscript[x, 18][t], Subscript[x, 19][t]} /. qUInjection[0, t]; 
     Chop[Thread[{RWB[t1], qFec[t1], qUri[t1]} -> 
        ExpandAll[{wb[t1], 2*fec[t1], 12*uri[t1]}*Exp[(-decaycte)*t1]]]]]; 

qUInjectionBioassayConst[decaycte_, t1_, period_] := Module[{t, tau, wb1, fec1, uri1}, 
    {wb1[t_], fec1[t_], uri1[t_]} = (qConstant[1, {#1, tau}, t, period] & ) /@ 
       Evaluate[ExpandAll[{RWB[tau], qFec[tau], qUri[tau]} /. qUInjectionBioassay1[
           decaycte, tau]]]; Thread[{RWB[t1], qFec[t1], qUri[t1]} -> 
       {wb1[t1], fec1[t1], uri1[t1]}]]; 

BioassayReportUranium["Injection", "Constant", decaycte_, t2_, period_] := 
   Module[{csreport, bio}, bio = {RWB[t], qFec[t], qUri[t]} /. 
       qUInjectionBioassayConst[decaycte, t, period]; csreport[t1_] = bio /. t -> t1; 
     Prepend[(Prepend[csreport[#1], #1] & ) /@ 
       Sort[Flatten[Append[Drop[daysirf, 1], t2]]], {"days", "Wb", "Fec24h", 
       "Urine24h"}]]; 

ResponseReport["Uranium", "Injection", "Acute", "ResponseFunction", decaycte_,t2_,  ___] := 
   ExpandAll[qUInjectionBioassay[decaycte, t2]]; 

ResponseReport["Uranium", "Injection", "Constant", "ResponseFunction",decaycte_, t2_, 
    period_, ___] := qUInjectionBioassayConst[decaycte, t2, period]; 

ResponseReport["Uranium", "Injection", "Acute", "BioassayReport", decaycte_, t2_, 
    ___] := BioassayReportUranium["Injection", "Acute", decaycte, t2]; 

ResponseReport["Uranium", "Injection", "Constant", "BioassayReport", decaycte_, t2_, 
    period_, ___] := BioassayReportUranium["Injection", "Constant", decaycte, t2, 
    period]; 

ResponseReport["Uranium", "Injection", "Acute", "CompartmentContents", decaycte_, t2_, 
    ___] := qUInjectionTable[decaycte, t2]; 

ResponseReport["Uranium", "Injection", "Constant", "CompartmentContents", decaycte_, 
    t2_, period_, ___] := "This option is only applicable for acute intake"; 

ResponseReport["Uranium", "Injection", "Acute", "GraphicsReport", decaycte_, tminmax_, 
    ___] := LogPlot[Evaluate[ExpandAll[{RWB[t1], qFec[t1], qUri[t1]} /. 
       qUInjectionBioassay1[decaycte, t1]]], Evaluate[Flatten[{t1, MinMax[tminmax]}]], 
    PlotRange -> All, PlotLegends -> {"RWB", "qFec", "qUri"}]; 

ResponseReport["Uranium", "Injection", "Constant", "GraphicsReport", decaycte_, 
    tminmax_, period_, ___] := 
   LogPlot[Evaluate[ExpandAll[{RWB[t1], qFec[t1], qUri[t1]} /. 
       qUInjectionBioassayConst[decaycte, t1, period]]], 
    Evaluate[Flatten[{t1, MinMax[tminmax]}]], PlotRange -> All, 
    PlotLegends -> {"RWB", "qFec", "qUri"}]; 

(* Uranium Ingestion*)

qUIngestion[lambda_,t_, fA_] := AcuteInput1[CompartMatrix[26, transfercoeffU /. kSItoBfA -> (6*fA)/(1 - fA), lambda], 
       PadLeft[{1}, 26], t, x]; 

qUIngestion[decaycte_, t_, period_, fA_] := Module[{tau},
  (qConstant[1, {#1, tau}, t, period] & ) /@ Evaluate[Table[Subscript[x, i][tau], {i, 1, 23}] /. 
   Chop[qUIngestion[decaycte, tau, fA]]]]

qUIngestionBioassay[lambda_, t1_, fA_] := Module[{t, wb, fec, uri}, 
    {wb[t_], fec[t_], uri[t_]} = {Total[Join[Table[Subscript[x, i][t], {i, 1, 19}], Table[Subscript[x, i][t], {i, 22, 23}]]], Subscript[x, 20][t], Subscript[x, 21][t]} /. 
       qUIngestion[0, t, fA]; Thread[{RWB[t1], qFec[t1], qUri[t1]} -> {wb[t1], fec[t1] - fec[t1 - 1], uri[t1] - uri[t1 - 1]}*Exp[(-lambda)*t1]]]; 

qUIngestion1[lambda_, t_, fA_] := Flatten[{RWB[t], If[t < 1, 0, qFec[t]], If[t < 1, 0, qUri[t]], 
Table[Subscript[x, i][t], {i, 1, 23}]}] /. Flatten[{qUIngestion[lambda, t, fA], qUIngestionBioassay[lambda,t, fA]}]; 

qUIngestionBioassay1[decaycte_, t1_, fA_] := Module[{t, wb, fec, uri}, 
          {wb[t_], fec[t_], uri[t_]} = {Total[Join[Table[Subscript[x, i][t], {i, 1, 19}], Table[Subscript[x, i][t], {i, 22, 23}]]], 
                     Subscript[x, 18][t], Subscript[x, 19][t]} /. qUIngestion[0, t, fA]; Thread[{RWB[t1], qFec[t1], qUri[t1]} -> 
                 ExpandAll[{wb[t1], 2*fec[t1] , 12*uri[t1]}*Exp[(-decaycte)*t1]]]];
                 
qUIngestionBioassayConst[decaycte_, t1_, period_, fA_] := 
   Module[{t, tau, wb1, fec1, uri1}, 
    {wb1[t_], fec1[t_], uri1[t_]} = (qConstant[1, {#1, tau}, t, period] & ) /@ 
       Evaluate[ExpandAll[{RWB[tau], qFec[tau], qUri[tau]} /. 
       qUIngestionBioassay1[decaycte, tau, fA]]]; 
     Thread[{RWB[t1], qFec[t1], qUri[t1]} -> {wb1[t1], fec1[t1], uri1[t1]}]];  

qUIngestionTable[lambda_,t2_,fA_] := Prepend[(Prepend[qUIngestion1[lambda, #1, fA], #1] & ) /@ Sort[Flatten[Append[Drop[daysirf, 1], t2]]], 
Flatten[{"Days", {"WB", "FEC24h", "URI24h"}, Drop[compartmentnamesU,-3]}]]; 

qUIngestionTable[decaycte_, t2_, period_, fA_] := Prepend[Chop[(Prepend[qUIngestion[decaycte, #, period, fA] ,
        #1] &) /@ Sort[Flatten[Append[Drop[daysirf, 1], t2]]]], Flatten[{"Days", Drop[compartmentnamesU,-3]}]];

BioassayReportUranium["Ingestion", "Acute", decaycte_, t2_, fA_] :=  
 Module[{ csreport, bio, t, t1}, 
    bio = {RWB[t], qFec[t], qUri[t]} /. 
    qUIngestionBioassay[decaycte, t, fA]; 
        csreport[t1_] = bio /. t -> t1; 
  Prepend[(Prepend[csreport[#1], #1] & )/@Sort[Flatten[Append[Drop[daysirf,1], t2]]], 
           {"days", "Wb", "Fec24h", "Urine24h"}]];
 
 BioassayReportUranium["Ingestion", "Constant", decaycte_, t2_, period_, fA_] :=  
 Module[{ csreport, bio, t, t1}, 
    bio = {RWB[t], qFec[t], qUri[t]} /. 
    qUIngestionBioassayConst[decaycte, t, period, fA]; 
        csreport[t1_] = bio /. t -> t1; 
  Prepend[(Prepend[csreport[#1], #1] & )/@Sort[Flatten[Append[Drop[daysirf,1], t2]]], 
           {"days", "Wb", "Fec24h", "Urine24h"}]];

ResponseReport["Uranium","Ingestion", "Acute", "ResponseFunction", decaycte_, t2_,period_, fA_,___]:=
qUIngestionBioassay[decaycte, t2, fA]//Chop//ExpandAll;

ResponseReport["Uranium","Ingestion", "Constant", "ResponseFunction", decaycte_, t2_,  period_,fA_,___]:=
qUIngestionBioassayConst[decaycte, t2, period, fA];  

ResponseReport["Uranium","Ingestion", "Acute", "BioassayReport", decaycte_, t2_,  period_,fA_,___]:=
BioassayReportUranium["Ingestion", "Acute", decaycte, t2, fA] ;

ResponseReport["Uranium","Ingestion", "Constant", "BioassayReport", decaycte_, t2_, period_,fA_,___]:=
BioassayReportUranium["Ingestion", "Constant", decaycte, t2, period, fA];

ResponseReport["Uranium","Ingestion", "Acute", "CompartmentContents", decaycte_, t2_, period_, fA_,___]:=
qUIngestionTable[decaycte,t2,  fA];

ResponseReport["Uranium","Ingestion", "Constant",  "CompartmentContents", decaycte_, t2_, period_, fA_,___]:=
qUIngestionTable[decaycte, t2, period, fA];
  
ResponseReport["Uranium","Ingestion", "Acute", "GraphicsReport", decaycte_, tminmax_,  period_, fA_,___]:=
LogPlot[Evaluate[ExpandAll[{RWB[t1], qFec[t1], qUri[t1]}/.qUIngestionBioassay1[decaycte, t1, fA]]], 
Evaluate[Flatten[{t1, MinMax[tminmax]}]],PlotRange->All, PlotLegends -> {"RWB", "qFec", "qUri"}];

ResponseReport["Uranium","Ingestion", "Constant", "GraphicsReport", decaycte_, tminmax_,period_, fA_,___]:=
LogPlot[Evaluate[ExpandAll[{RWB[t1], qFec[t1], qUri[t1]}/.qUIngestionBioassayConst[decaycte, t1, period, fA]]], 
Evaluate[Flatten[{t1, MinMax[tminmax]}]],PlotRange->All, PlotLegends -> {"RWB", "qFec", "qUri"}];     

(* Uranium Inhalation*)

qUInhalation[lambda_,t1_,fA_,idf_,fr_, sr_, ss_] := 
   Module[{rt, blood, oes, initialconditions, b1, transfercoeff, xNumbers}, 
    {rt, blood, oes} = RTRetention[idf,fr, sr, ss]; initialconditions = 
      PadRight[{0}, 24]; b1 = {blood, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
       0, 0, 0, 0, 0, 0, oes, 0, 0}; transfercoeff = Drop[transfercoeffU,{35,37}] /. 
       kSItoBfA -> 6*(fA/(1 - fA)); xNumbers = 
      Flatten[{Table[Subscript[x, i][t1], {i, 1, 24}], RTract[t1]}]; 
     Thread[xNumbers -> Evaluate[(xNumbers /. SystemDSolve[CompartMatrix[24, transfercoeff], 
            initialconditions, b1, t, t1, x] /. RTract[t1] -> 
           Evaluate[rt /. t -> t1])*Exp[(-lambda)*t1]]]]; 

(* Debajo se muestra qUInhalationBioassay que para el pulmon suma la sangre y los sof t correspondientes al pulmon, pero no se suman en el TR*)

qUInhalationBioassay[lambda_,t1_,fA_,idf_,fr_,sr_,ss_] := 
   Module[{qTR1, TRx, rt1, rt, lung, qwbody1, qlungs1, qfec1, quri1, qwbody, qlungs, 
     qfec24h, quri24h}, qTR1[t_] := qTRRetention[t, idf, fr, sr, ss, 0]; 
     TRx = Table[Subscript[x, i][t], {i, 1, 11}]; 
     rt1 = {"RapidDissolutionSubsystem", "SlowDissolutionSubsystem"} /. qTR1[t]; 
     rt = TRx /. rt1; lung = Drop[TRx, {6, 9}] /. rt1; 
     {qwbody1[t_], qlungs1[t_], qfec1[t_], quri1[t_]} = 
      {Total[Evaluate[Flatten[{Table[Subscript[x, i][t], {i, 1, 19}], Table[Subscript[x, i][t], 
             {i, 22, 24}]}]]] + RTract[t], (Subscript[x, 1][t] + Subscript[x, 2][t])*
          0.125 + (Subscript[x, 3][t] + Subscript[x, 4][t] + Subscript[x, 5][t])*0.009, 
        Subscript[x, 20][t], Subscript[x, 21][t]} /. qUInhalation[0,t,fA,idf,fr,sr,ss]; 
        {qwbody, qlungs, qfec24h, quri24h} = {qwbody1[t], qlungs1[t], qfec1[t] - qfec1[t - 1], 
        quri1[t] - quri1[t - 1]}; 
     Thread[{RTract[t1], RLungs[t1], RWB[t1], qFec[t1], qUri[t1]} -> 
        Exp[(-lambda)*t1]*{Total[Flatten[rt]], qlungs + 
           Total[Flatten[lung]], qwbody, qfec24h, quri24h} /. t -> t1]]//ExpandAll; 

(* EN esta se calcula la tasa instantanea de la excrecion fecal y urinaria es la adecuada para casos de incorporacion constante*)

qUInhalationBioassay1[lambda_,t1_,fA_,idf_,fr_,sr_,ss_] := 
   Module[{qTR1, TRx, rt1, rt, lung, qwbody1, qlungs1, qfec1, quri1, qwbody, qlungs, 
     qfec24h, quri24h}, qTR1[t_] := qTRRetention[t, idf, fr, sr, ss, 0]; 
     TRx = Table[Subscript[x, i][t], {i, 1, 11}]; 
     rt1 = {"RapidDissolutionSubsystem", "SlowDissolutionSubsystem"} /. qTR1[t]; 
     rt = TRx /. rt1; lung = Drop[TRx, {6, 9}] /. rt1; 
     {qwbody1[t_], qlungs1[t_], qfec1[t_], quri1[t_]} = 
      {Total[Flatten[{Table[Subscript[x, i][t], {i, 1, 19}], Table[Subscript[x, i][t], 
             {i, 22, 24}]}]] + RTract[t], (Subscript[x, 1][t] + Subscript[x, 2][t])*
          0.125 + (Subscript[x, 3][t] + Subscript[x, 4][t] + Subscript[x, 5][t])*0.009, 
        Subscript[x, 18][t], Subscript[x, 19][t]} /. qUInhalation[0, t, fA, idf, fr, sr, ss]; 
        {qwbody, qlungs, qfec24h, quri24h} = {qwbody1[t], qlungs1[t], 
       2*qfec1[t], 12*quri1[t]}; 
     Thread[{RTract[t1], RLungs[t1], RWB[t1], qFec[t1], qUri[t1]} -> 
        Exp[(-lambda)*t1]*{Total[Flatten[rt]], qlungs + 
           Total[Flatten[lung]], qwbody, qfec24h, quri24h} /. t -> t1]]//ExpandAll; 
           
 (* Debajo se muestra qUInhalationBioassay1 que corresponde a  la antigua funcion 
 que no suma la sangre ni los sof t en el pulmon*)

qUInhalationBioassay2[lambda_,t1_,fA_,idf_,fr_,sr_,ss_] := 
  Module[{qTR1,TRx, rt1, rt, lung, qwbody1, qfec1, quri1, qwbody, qfec24h, quri24h}, 
   qTR1[t_] := qTRRetention[t, idf,fr, sr, ss, 0]; TRx = Table[Subscript[x, i][t], {i, 1, 11}];
    rt1 = {"RapidDissolutionSubsystem", "SlowDissolutionSubsystem"} /. qTR1[t]; 
    rt = TRx /. rt1; lung = Drop[TRx, {6, 9}] /. rt1; 
    {qwbody1[t_], qfec1[t_], quri1[t_]} = 
     {Total[Flatten[{Table[Subscript[x, i][t], {i, 1, 19}], 
           Table[Subscript[x, i][t], {i, 22, 24}]}]] + RTract[t], 
       Subscript[x, 20][t], Subscript[x, 21][t]} /. qUInhalation[0 ,t ,fA,idf, fr, sr, ss]; 
       {qwbody, qfec24h, quri24h} = {qwbody1[t], qfec1[t] - qfec1[t - 1], quri1[t] - quri1[t - 1]}; 
    Thread[{RTract[t1], RLungs[t1], RWB[t1], qFec[t1], qUri[t1]} -> 
       Exp[(-lambda)*t1]*{Total[Flatten[rt]], Total[Flatten[lung]], qwbody, 
         qfec24h, quri24h} /. t -> t1]]; 
         
BioassayReportUranium["Inhalation", "Acute", decaycte_, t2_, fA_, idf_, fr_, sr_, ss_] := 
     Module[{csreport, bio}, bio = {RLungs[t], qFec[t], qUri[t]} /. qUInhalationBioassay[decaycte, t, fA, idf, fr, sr, ss]; csreport[t1_] = bio /. t -> t1; 
        Prepend[(Prepend[csreport[#1], #1] & ) /@ Sort[Flatten[Append[Drop[daysirf, 1], t2]]], {"days", "Lung", "Fec24h", "Urine24h"}]]; 

qUInhalationTable[lambda_,t2_, fA_, idf_,  fr_, sr_, ss_] := Module[{solUS, list1, list2}, 
solUS[t_] = Table[Subscript[x, i][t], {i, 1, 24}] /. qUInhalation[lambda, t, fA, idf, fr, sr, ss]; 
list1 = BioassayReportUranium["Inhalation", "Acute", lambda, t2, fA, idf,  fr, sr, ss]; 
 list2 = Prepend[(solUS[#1] & )/@Sort[Flatten[Append[Drop[daysirf, 1], t2]]], 
 Flatten[Drop[compartmentnamesU, -2]]]; Transpose[Join[Transpose[list1], Transpose[list2]]]];
    
qUInhalationBioassayConst[decaycte_, t1_, period_, fA_, idf_, fr_, sr_, ss_] := 
   Module[{t, tau, lung, fec, uri, lung1, fec1, uri1}, 
    {lung[t_], fec[t_], uri[t_]} = Evaluate[Expand[{RLungs[t], qFec[t], qUri[t]} /. 
         qUInhalationBioassay1[decaycte, t, fA, idf, fr, sr, ss]]]; 
     {lung1[t_], fec1[t_], uri1[t_]} = (qConstant[1, {#1, tau}, t, period] & ) /@ 
       Evaluate[ExpandAll[{lung[tau]*Exp[(-decaycte)*tau], 
          fec[tau]*Exp[(-decaycte)*tau], uri[tau]*Exp[(-decaycte)*tau]}]]; 
     Thread[{RLungs[t1], qFec[t1], qUri[t1]} -> {lung1[t1], fec1[t1], uri1[t1]}]];   

BioassayReportUranium["Inhalation", "Constant", decaycte_, t2_, period_, fA_, idf_, fr_, sr_, ss_] := 
     Module[{csreport, bio}, bio = {RLungs[t], qFec[t], qUri[t]} /. qUInhalationBioassayConst[decaycte, t, period, fA, idf, fr, sr, ss]; csreport[t1_] = bio /. t -> t1; 
        Prepend[(Prepend[csreport[#1], #1] & ) /@ Sort[Flatten[Append[Drop[daysirf, 1], t2]]], {"days", "Lung", "Fec24h", "Urine24h"}]]; 

ResponseReport["Uranium", "Inhalation", "Acute", "ResponseFunction", decaycte_, t2_, period_,fAing_,{fA_, fr_, sr_, ss_}, idf_] := 
     qUInhalationBioassay[decaycte, t2, fA, idf, fr, sr, ss]; 

ResponseReport["Uranium", "Inhalation", "Constant", "ResponseFunction", decaycte_, t2_, period_,fAing_,{fA_, fr_, sr_, ss_}, idf_] := 
qUInhalationBioassayConst[decaycte, t2, period, fA, idf, fr, sr, ss]; 

ResponseReport["Uranium", "Inhalation", "Acute", "BioassayReport", decaycte_, t2_, period_, fAing_, {fA_, fr_, sr_, ss_}, idf_] := 
     BioassayReportUranium["Inhalation", "Acute", decaycte, t2, fA, idf, fr, sr, ss]; 

ResponseReport["Uranium", "Inhalation", "Constant", "BioassayReport", decaycte_, t2_, period_,fAing_, {fA_, fr_, sr_, ss_}, idf_] := 
     BioassayReportUranium["Inhalation", "Constant", decaycte, t2, period, fA, idf, fr, sr, ss]; 

ResponseReport["Uranium", "Inhalation", "Acute", "CompartmentContents", decaycte_, t2_, period_, fAing_,{fA_, fr_, sr_, ss_}, idf_] := 
     qUInhalationTable[decaycte, t2, fA, idf, fr, sr, ss]; 

ResponseReport["Uranium", "Inhalation", "Constant", "CompartmentContents", decaycte_, t2_, period_,fAing_, fA_, {fA_, fr_, sr_, ss_}, idf_] := "Optionn only available  for acute intake"; 

ResponseReport["Uranium", "Inhalation", "Acute", "GraphicsReport", decaycte_, tminmax_, period_, fAing_, {fA_, fr_, sr_, ss_}, idf_] := 
     LogPlot[Evaluate[ExpandAll[{RLungs[t1], qFec[t1], qUri[t1]} /. qUInhalationBioassay[decaycte, t1, fA, idf, fr, sr, ss]]], Evaluate[Flatten[{t1, MinMax[tminmax]}]], 
       PlotRange -> All, PlotLegends -> {"Lungs", "qFec", "qUri"}]; 

ResponseReport["Uranium", "Inhalation", "Constant", "GraphicsReport", decaycte_, tminmax_, period_, fAing_,{fA_, fr_, sr_, ss_}, idf_] := 
     LogPlot[Evaluate[ExpandAll[{RLungs[t1], qFec[t1], qUri[t1]} /. qUInhalationBioassayConst[decaycte, t1, period, fA, idf, fr, sr, ss]]], 
       Evaluate[Flatten[{t1, MinMax[tminmax]}]], PlotRange -> All, PlotLegends -> {"Lungs", "qFec", "qUri"}]; 

(*Iodium*)
(* Injection *)

qIInjection[lambda_, t_] := AcuteInput1[CompartMatrix[24, transfercoeffIinj, 
         lambda], PadRight[{1}, 24], t, x]; 

qIInjectionBioassay[lambda_, t1_] := Module[{t, wb, thy, fec, uri}, 
          {wb[t_], thy[t_], fec[t_], uri[t_]} = 
              {Total[Drop[Table[Subscript[x, i][t], {i, 1, 24}], {17, 18}]], 
                    Subscript[x, 4][t] + Subscript[x, 5][t], Subscript[x, 17][t], 
                    Subscript[x, 18][t]} /. qIInjection[0, t]; 
           Thread[{RWB[t1], RThy[t1], qFec[t1], qUri[t1]} -> 
                 {wb[t1], thy[t1], fec[t1] - fec[t1 - 1], uri[t1] - uri[t1 - 1]}*
                    Exp[(-lambda)*t1]]]; 

qIInjectionBioassay1[lambda_, t1_] := Module[{t, wb, thy, fec, uri}, 
          {wb[t_], thy[t_], fec[t_], uri[t_]} = 
              {Total[Drop[Table[Subscript[x, i][t], {i, 1, 24}], {17, 18}]], 
                    Subscript[x, 4][t] + Subscript[x, 5][t], Subscript[x, 24][t], 
                    Subscript[x, 16][t]} /. qIInjection[0, t]; 
           Thread[{RWB[t1], RThy[t1], qFec[t1], qUri[t1]} -> 
                 ExpandAll[{wb[t1], thy[t1], 2*fec[t1], 12*uri[t1]}*Exp[(-lambda)*t1]]]]; 

qIInjection1[lambda_, t_] := Flatten[{RWB[t], RThy[t], If[t < 1, 0, qFec[t]], 
                If[t < 1, 0, qUri[t]], Table[Subscript[x, i][t], {i, 1, 24}]}] /. 
          Flatten[{qIInjection[lambda, t], qIInjectionBioassay[lambda, t]}]; 

qIInjectionTable[decaycte_, t2_] := 
       Prepend[Chop[(Prepend[qIInjection1[decaycte, #1], #1] & ) /@ 
                Sort[Flatten[Append[Drop[daysirf, 1], t2]]]], 
          Flatten[{"Days", {"WB", "Thy", "FEC24h", "URI24h"}, compartmentnamesIinj}]]; 

qIInjectionTable[decaycte_, t2_] := 
       Prepend[Chop[(Prepend[qIInjection1[decaycte, #1], #1] & ) /@ 
                Sort[Flatten[Append[Drop[daysirf, 1], t2]]]], 
          Flatten[{"Days", {"WB", "Thy", "FEC24h", "URI24h"}, compartmentnamesIinj}]]; 

qIInjection[decaycte_, t_, period_] := 
     Module[{tau}, (qConstant[1, {#1, tau}, t, period] & ) /@ 
           Evaluate[Table[Subscript[x, i][tau], {i, 1, 24}] /. 
                 Chop[qIInjection[decaycte, tau]]]];

qIInjectionBioassayConst[decaycte_, t1_, period_] := 
       Module[{t, tau, wb1, thy1, fec1, uri1}, 
          {wb1[t_], thy1[t_], fec1[t_], uri1[t_]} = 
              (qConstant[1, {#1, tau}, t, period] & ) /@ 
                 Evaluate[ExpandAll[{RWB[tau], RThy[tau], qFec[tau], qUri[tau]} /. 
                          qIInjectionBioassay1[decaycte, tau]]]; 
           Thread[{RWB[t1], RThy[t1], qFec[t1], qUri[t1]} -> {wb1[t1], thy1[t1], 
                    fec1[t1], uri1[t1]}]]; 

qIInjectionTable[decaycte_, t2_, period_] := 
       Prepend[Chop[(Prepend[qIInjection[decaycte, #1, period], #1] & ) /@ 
                Sort[Flatten[Append[Drop[daysirf, 1], t2]]]], 
          Flatten[{"Days", compartmentnamesIinj}]]; 

BioassayReportIodium["Injection", "Acute", decaycte_, t2_] := 
     Module[{csreport, bio}, bio = {RWB[t], RThy[t], qFec[t], qUri[t]} /. 
            qIInjectionBioassay[decaycte, t]; csreport[t1_] = bio /. t -> t1; 
        Prepend[(Prepend[csreport[#1], #1] & ) /@ 
            Sort[Flatten[Append[Drop[daysirf, 1], t2]]], {"days", "Wb", "Thy", 
            "Fec24h", "Urine24h"}]]; 

BioassayReportIodium["Injection", "Constant", decaycte_, t2_, period_] := 
     Module[{csreport, bio}, bio = {RWB[t], RThy[t], qFec[t], qUri[t]} /. 
            qIInjectionBioassayConst[decaycte, t, period]; 
        csreport[t1_] = bio /. t -> t1; Prepend[(Prepend[csreport[#1], #1] & ) /@ 
            Sort[Flatten[Append[Drop[daysirf, 1], t2]]], {"days", "Wb", "Thy", 
            "Fec24h", "Urine24h"}]]; 

ResponseReport["Iodium", "Injection", "Acute", "ResponseFunction", decaycte_,t2_, 
       ___] := ExpandAll[qIInjectionBioassay1[decaycte, t2]]; 

ResponseReport["Iodium", "Injection", "Constant", "ResponseFunction", decaycte_, 
       t2_, period_, ___] := 
    qIInjectionBioassayConst[decaycte, t2, period]; 

ResponseReport["Iodium", "Injection", "Acute", "BioassayReport", decaycte_, t2_, 
       ___] := BioassayReportIodium["Injection", "Acute", decaycte, t2]; 

ResponseReport["Iodium", "Injection", "Constant", "BioassayReport", decaycte_, 
       t2_, period_, ___] := BioassayReportIodium["Injection", "Constant", decaycte, 
       t2, period]; 

ResponseReport["Iodium", "Injection", "Acute", "CompartmentContents", decaycte_, 
       t2_, ___] := qIInjectionTable[decaycte, t2]; 

ResponseReport["Iodium", "Injection", "Constant", "CompartmentContents", 
       decaycte_, t2_, period_, ___] := qIInjectionTable[decaycte, t2, period]; 

ResponseReport["Iodium", "Injection", "Acute", "GraphicsReport", decaycte_, 
       tminmax_, ___] := 
     LogPlot[Evaluate[ExpandAll[{RWB[t1], RThy[t1], qFec[t1], qUri[t1]} /. 
             qIInjectionBioassay1[decaycte, t1]]], 
       Evaluate[Flatten[{t1, MinMax[tminmax]}]], PlotRange -> All, 
       PlotLegends -> {"RWB", "Thy", "qFec", "qUri"}]; 

ResponseReport["Iodium", "Injection", "Constant", "GraphicsReport", decaycte_, 
       tminmax_, period_, ___] := 
     LogPlot[Evaluate[ExpandAll[{RWB[t1], RThy[t1], qFec[t1], qUri[t1]} /. 
             qIInjectionBioassayConst[decaycte, t1, period]]], 
       Evaluate[Flatten[{t1, MinMax[tminmax]}]], PlotRange -> All, 
       PlotLegends -> {"RWB", "Thy", "qFec", "qUri"}]; 

(*Ingestion*)

qIIngestion[decaycte_, t_, fA_] := 
     Chop[AcuteInput1[CompartMatrix[28, transfercoeffI /. 
             kSItoBfA -> 6*(fA/(1 - fA)), decaycte], PadLeft[{1}, 28], t, x]]; 

qIIngestionBioassay[lambda_, t1_, fA_] := 
     Chop[Module[{t, wb, thy, fec, uri}, {wb[t_], thy[t_], fec[t_], uri[t_]} = 
            {Total[Drop[Table[Subscript[x, i][t], {i, 1, 28}], {17, 18}]], 
                Subscript[x, 4][t] + Subscript[x, 5][t], Subscript[x, 17][t], 
                Subscript[x, 18][t]} /. qIIngestion[0, t, fA]; 
          Thread[{RWB[t1], RThy[t1], qFec[t1], qUri[t1]} -> 
              {wb[t1], thy[t1], fec[t1] - fec[t1 - 1], uri[t1] - uri[t1 - 1]}*
                Exp[(-lambda)*t1]]]]; 

qIIngestionBioassay1[lambda_, t1_, fA_] := 
     Chop[Module[{t, wb, thy, fec, uri}, {wb[t_], thy[t_], fec[t_], uri[t_]} = 
            {Total[Drop[Table[Subscript[x, i][t], {i, 1, 28}], {17, 18}]], 
                Subscript[x, 4][t] + Subscript[x, 5][t], Subscript[x, 24][t], 
                Subscript[x, 16][t]} /. qIIngestion[0, t, fA]; 
          Thread[{RWB[t1], RThy[t1], qFec[t1], qUri[t1]} -> 
              ExpandAll[{wb[t1], thy[t1], 2*fec[t1], 12*uri[t1]}*Exp[(-lambda)*t1]]]]]; 

qIIngestion1[lambda_, t_, fA_] := 
     Flatten[{RWB[t], RThy[t], If[t < 1, 0, qFec[t]], If[t < 1, 0, qUri[t]], 
           Table[Subscript[x, i][t], {i, 1, 24}]}] /. 
       Flatten[{qIIngestion[lambda, t, fA], qIIngestionBioassay[lambda, t, fA]}]; 

qIIngestionTable[decaycte_, t2_, fA_] := 
     Prepend[Chop[(Prepend[qIIngestion1[decaycte, #1, fA], #1] & ) /@ 
           Sort[Flatten[Append[Drop[daysirf, 1], t2]]]], 
       Flatten[{"Days", {"WB", "Thy", "FEC24h", "URI24h"}, 
           Drop[compartmentnamesI, -4]}]]; 

BioassayReportIodium["Ingestion", "Acute", decaycte_, t2_, fA_] := 
     Module[{csreport, bio, t, t1}, bio = {RWB[t], RThy[t], qFec[t], qUri[t]} /. 
            qIIngestionBioassay[decaycte, t, fA]; csreport[t1_] = bio /. t -> t1; 
        Prepend[(Prepend[csreport[#1], #1] & ) /@ 
            Sort[Flatten[Append[Drop[daysirf, 1], t2]]], {"days", "Wb", "Thy", 
            "Fec24h", "Urine24h"}]]; 

qIIngestion[decaycte_, t_, period_, fA_] := 
   Module[{tau}, (qConstant[1, {#1, tau}, t, period] & ) /@ 
       Evaluate[Table[Subscript[x, i][tau], {i, 1, 28}] /. 
           Chop[qIIngestion[decaycte, tau, fA]]]]

qIIngestionTable[decaycte_, t2_, period_, fA_] := 
     Prepend[Chop[(Prepend[qIIngestion[decaycte, #1, period, fA], #1] & ) /@ 
           Sort[Flatten[Append[Drop[daysirf, 1], t2]]]], 
       Flatten[{"Days", compartmentnamesI}]]; 

qIIngestionBioassayConst[decaycte_, t1_, period_, fA_] := 
     Module[{t, tau, thy1, wb1, fec1, uri1}, 
       {wb1[t_], thy1[t_], fec1[t_], uri1[t_]} = 
          (qConstant[1, {#1, tau}, t, period] & ) /@ 
            Evaluate[ExpandAll[{RWB[tau], RThy[tau], qFec[tau], qUri[tau]} /. 
                  qIIngestionBioassay1[decaycte, tau, fA]]]; 
        Thread[{RWB[t1], RThy[t1], qFec[t1], qUri[t1]} -> {wb1[t1], thy1[t1], 
              fec1[t1], uri1[t1]}]]; 

BioassayReportIodium["Ingestion", "Constant", decaycte_, t2_, period_, fA_] := 
     Module[{csreport, bio}, bio = {RWB[t], RThy[t], qFec[t], qUri[t]} /. 
            qIIngestionBioassayConst[decaycte, t, period, fA]; 
        csreport[t1_] = bio /. t -> t1; Prepend[(Prepend[csreport[#1], #1] & ) /@ 
            Sort[Flatten[Append[Drop[daysirf, 1], t2]]], {"days", "Wb", "Thy", 
            "Fec24h", "Urine24h"}]]; 
            
ResponseReport["Iodium","Ingestion", "Acute", "ResponseFunction", decaycte_, t2_, period_, fA_,___]:=
qIIngestionBioassay1[decaycte, t2, fA];

ResponseReport["Iodium", "Ingestion", "Constant", "ResponseFunction",decaycte_, t2_, period_, fA_,___] := 
  qIIngestionBioassayConst[decaycte, t2, period, fA]; 

ResponseReport["Iodium", "Ingestion", "Acute", "BioassayReport", decaycte_, t2_, 
    period_, fA_, ___] := BioassayReportIodium["Ingestion", "Acute", decaycte, 
    t2, fA]; 

ResponseReport["Iodium", "Ingestion", "Constant", "BioassayReport", decaycte_, 
    t2_, period_, fA_, ___] := BioassayReportIodium["Ingestion", "Constant", 
    decaycte, t2, period, fA]; 

ResponseReport["Iodium", "Ingestion", "Acute", "CompartmentContents", decaycte_, 
    t2_, period_, fA_, ___] := qIIngestionTable[decaycte, t2, fA]; 

ResponseReport["Iodium", "Ingestion", "Constant", "CompartmentContents", 
    decaycte_, t2_, period_, fA_, ___] := qIIngestionTable[decaycte, t2, period, 
    fA]; 

ResponseReport["Iodium", "Ingestion", "Acute", "GraphicsReport", decaycte_, 
    tminmax_, period_, fA_, ___] := 
   LogPlot[Evaluate[ExpandAll[{RWB[t1], RThy[t1], qFec[t1], qUri[t1]} /. 
       qIIngestionBioassay1[decaycte, t1, fA]]], 
    Evaluate[Flatten[{t1, MinMax[tminmax]}]], PlotRange -> All, 
    PlotLegends -> {"RWB", "Thy", "qFec", "qUri"}]; 

ResponseReport["Iodium", "Ingestion", "Constant", "GraphicsReport", decaycte_, 
    tminmax_, period_, fA_, ___] := 
   LogPlot[Evaluate[ExpandAll[{RWB[t1], RThy[t1], qFec[t1], qUri[t1]} /. 
       qIIngestionBioassayConst[decaycte, t1, period, fA]]], 
    Evaluate[Flatten[{t1, MinMax[tminmax]}]], PlotRange -> All, 
    PlotLegends -> {"RWB", "Thy", "qFec", "qUri"}]; 



(*Inhalation*)

qIInhalation[decaycte_, t1_, fA_, idf_, fr_, sr_, ss_] := 
     Module[{rt, blood, oes, initialconditions, b1, transfercoeff, xNumbers}, 
       {rt, blood, oes} = RTRetention[idf, fr, sr, ss]; initialconditions = 
          PadRight[{0}, 27]; b1 = {blood, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
            0, 0, 0, 0, 0, 0, 0, 0, 0, oes, 0, 0}; transfercoeff = 
          transfercoeffIinh /. kSItoBfA -> 6*(fA/(1 - fA)); 
        xNumbers = Flatten[{Table[Subscript[x, i][t1], {i, 1, 27}], RTract[t1]}]; 
        Thread[xNumbers -> Evaluate[xNumbers /. SystemDSolve[CompartMatrix[27, 
                        transfercoeff], initialconditions, b1, t, t1, x] /. 
                  RTract[t1] -> Evaluate[rt /. t -> t1]]*Exp[(-decaycte)*t1]]]; 

qIInhalationBioassay[lambda_, t1_, fA_, idf_, fr_, sr_, ss_] := 
     Module[{qTR1, TRx, rt1, rt, qthy1, qthy, qwbody1, qfec1, quri1, qwbody, 
         qfec24h, quri24h}, qTR1[t_] := qTRRetention[t, idf, fr, sr, ss, 0]; 
        TRx = Table[Subscript[x, i][t], {i, 1, 11}]; 
        rt1 = {"RapidDissolutionSubsystem", "SlowDissolutionSubsystem"} /. qTR1[t]; 
        rt = TRx /. rt1; {qwbody1[t_], qfec1[t_], quri1[t_], qthy1[t_]} = 
          {Total[Flatten[{Table[Subscript[x, i][t], {i, 1, 16}], 
                      Table[Subscript[x, i][t], {i, 19, 27}]}]] + RTract[t], 
              Subscript[x, 17][t], Subscript[x, 18][t], Subscript[x, 4][t] + 
                Subscript[x, 5][t]} /. qIInhalation[0, t, fA, idf, fr, sr, ss]; 
        {qwbody, qfec24h, quri24h, qthy} = {qwbody1[t], qfec1[t] - qfec1[t - 1], 
            quri1[t] - quri1[t - 1], qthy1[t]}; 
        Thread[{RTract[t1], RThy[t1], RWB[t1], qFec[t1], qUri[t1]} -> 
              Exp[(-lambda)*t1]*{Total[Flatten[rt]], qthy, qwbody, qfec24h, quri24h} /. 
            t -> t1]]; 

qIInhalationBioassay1[lambda_, t1_, fA_, idf_, fr_, sr_, ss_] := 
     Module[{qTR1, TRx, rt1, rt, qthy1, qthy, qwbody1, qfec1, quri1, qwbody, 
         qfec24h, quri24h}, qTR1[t_] := qTRRetention[t, idf, fr, sr, ss, 0]; 
        TRx = Table[Subscript[x, i][t], {i, 1, 11}]; 
        rt1 = {"RapidDissolutionSubsystem", "SlowDissolutionSubsystem"} /. qTR1[t]; 
        rt = TRx /. rt1; {qwbody1[t_], qfec1[t_], quri1[t_], qthy1[t_]} = 
          {Total[Flatten[{Table[Subscript[x, i][t], {i, 1, 16}], 
                      Table[Subscript[x, i][t], {i, 19, 27}]}]] + RTract[t], 
              Subscript[x, 24][t], Subscript[x, 16][t], Subscript[x, 4][t] + 
                Subscript[x, 5][t]} /. qIInhalation[0, t, fA, idf, fr, sr, ss]; 
        {qwbody, qfec24h, quri24h, qthy} = {qwbody1[t], qfec1[t], quri1[t], 
            qthy1[t]}; Thread[{RTract[t1], RThy[t1], RWB[t1], qFec[t1], qUri[t1]} -> 
              Exp[(-lambda)*t1]*{Total[Flatten[rt]], qthy, qwbody, 2*qfec24h, 
                  12*quri24h} /. t -> t1]]; 

qIInhalationTable[decaycte_, t2_, fA_, idf_, fr_, sr_, ss_] := 
     Module[{solUS}, 
       solUS[t_] = Evaluate[Flatten[{Table[Subscript[x, i][t], {i, 1, 27}], 
                  RTract[t]}] /. qIInhalation[decaycte, t, fA, idf, fr, sr, ss]]; 
        Prepend[Chop[(Prepend[solUS[#1], #1] & ) /@ 
              Sort[Flatten[Append[Drop[daysirf, 1], t2]]]], 
          Flatten[{"Day", compartmentnamesIinh, "RT"}]]]; 

BioassayReportIodium["Inhalation", "Acute", decaycte_, t2_, fA_, idf_, fr_, sr_, 
       ss_] := Module[{csreport, bio, t, t1}, 
       bio = {RWB[t], RThy[t], qFec[t], qUri[t]} /. qIInhalationBioassay[decaycte, 
              t, fA, idf, fr, sr, ss]; csreport[t1_] = bio /. t -> t1; 
        Prepend[(Prepend[csreport[#1], #1] & ) /@ 
            Sort[Flatten[Append[Drop[daysirf, 1], t2]]], {"days", "Wb", "Thy", 
            "Fec24h", "Urine24h"}]]; 

(*BioassayReportIodium1["Inhalation", "Acute", decaycte_, t2_, fA_, idf_, fr_, sr_, 
       ss_] := Module[{csreport, bio, t, t1}, 
       bio = {RWB[t], RThy[t], qFec[t], qUri[t]} /. qIInhalationBioassay1[decaycte, 
              t, fA, idf, fr, sr, ss]; csreport[t1_] = bio /. t -> t1; 
        Prepend[(Prepend[csreport[#1], #1] & ) /@ 
            Sort[Flatten[Append[Drop[daysirf, 1], t2]]], {"days", "Wb", "Thy", 
            "Fec24h", "Urine24h"}]]*)

qIInhalationBioassayConst[decaycte_, t1_, period_, fA_, idf_, fr_, sr_, ss_] := 
     Module[{t, tau, wb, thy, fec, uri, wb1, thy1, fec1, uri1}, 
       {wb[t_], thy[t_], fec[t_], uri[t_]} = 
          {Total[Flatten[{Table[Subscript[x, i][t], {i, 1, 16}], 
                      Table[Subscript[x, i][t], {i, 19, 27}]}]] + RTract[t], 
              Subscript[x, 4][t] + Subscript[x, 5][t], Subscript[x, 24][t], 
              Subscript[x, 16][t]} /. qIInhalation[0, t, fA, idf, fr, sr, ss]; 
        {wb1[t_], thy1[t_], fec1[t_], uri1[t_]} = 
          (qConstant[1, {#1, tau}, t, period] & ) /@ 
            Evaluate[ExpandAll[{wb[tau]*Exp[(-decaycte)*tau], 
                  thy[tau]*Exp[(-decaycte)*tau], 2*fec[tau]*Exp[(-decaycte)*tau], 
                  12*uri[tau]*Exp[(-decaycte)*tau]}]]; 
        Thread[{RWB[t1], RThy[t1], qFec[t1], qUri[t1]} -> {wb1[t1], thy1[t1], 
              fec1[t1], uri1[t1]}]]; 

BioassayReportIodium["Inhalation", "Constant", decaycte_, t2_, period_, fA_, 
       idf_, fr_, sr_, ss_] := Module[{csreport, bio}, 
       bio = {RWB[t], RThy[t], qFec[t], qUri[t]} /. qIInhalationBioassayConst[
              decaycte, t, period, fA, idf, fr, sr, ss]; 
        csreport[t1_] = bio /. t -> t1; Prepend[(Prepend[csreport[#1], #1] & ) /@ 
            Sort[Flatten[Append[Drop[daysirf, 1], t2]]], {"days", "Wb", "Thy", 
            "Fec24h", "Urine24h"}]]; 
            
ResponseReport["Iodium", "Inhalation", "Acute", "ResponseFunction", decaycte_, 
    t2_, period_,fAing_, {fA_, fr_, sr_, ss_}, idf_] := 
   qIInhalationBioassay[decaycte, t2, fA, idf, fr, sr, ss]; 

ResponseReport["Iodium", "Inhalation", "Constant", "ResponseFunction",  decaycte_, 
    t2_, period_,fAing_, {fA_, fr_, sr_, ss_}, idf_] := 
   qIInhalationBioassayConst[decaycte, t2, period, fA, idf, fr, sr, ss] ; 

ResponseReport["Iodium", "Inhalation", "Acute", "BioassayReport", decaycte_, t2_, 
    period_, fAing_,{fA_, fr_, sr_, ss_}, idf_] := BioassayReportIodium["Inhalation", 
    "Acute", decaycte, t2, fA, idf, fr, sr, ss]; 

ResponseReport["Iodium", "Inhalation", "Constant", "BioassayReport", decaycte_, 
    t2_, period_, fAing_,{fA_, fr_, sr_, ss_}, idf_] := BioassayReportIodium["Inhalation", 
    "Constant", decaycte, t2, period, fA, idf, fr, sr, ss]; 

ResponseReport["Iodium", "Inhalation", "Acute", "CompartmentContents", decaycte_, 
    t2_, period_, fAing_,{fA_, fr_, sr_, ss_}, idf_] := qIInhalationTable[decaycte, t2, 
    fA, idf, fr, sr, ss]; 

ResponseReport["Iodium","Inhalation", "Constant",  "CompartmentContents", decaycte_, t2_, period_, fAing_, {fA_, fr_, sr_, ss_}, idf_]:=
"This function is only available for acute intake"; 
  
ResponseReport["Iodium","Inhalation", "Acute", "GraphicsReport", decaycte_, tminmax_,period_,fAing_,{fA_, fr_, sr_, ss_}, idf_]:=
LogPlot[Evaluate[ExpandAll[{RWB[t1],RThy[t1], qFec[t1], qUri[t1]}/.qIInhalationBioassay1[decaycte, t1, fA, idf, fr, sr, ss]]], 
Evaluate[Flatten[{t1, MinMax[tminmax]}]],PlotRange->All, PlotLegends -> {"RWB", "Thy","qFec", "qUri"}];

ResponseReport["Iodium","Inhalation", "Constant", "GraphicsReport", decaycte_, tminmax_,period_, fAing_,{fA_, fr_, sr_, ss_}, idf_]:=
LogPlot[Evaluate[ExpandAll[{RWB[t1], RThy[t1], qFec[t1], qUri[t1]}/.qIInhalationBioassayConst[decaycte, t1, period, fA, idf, fr, sr, ss]]], 
Evaluate[Flatten[{t1, MinMax[tminmax]}]],PlotRange->All, PlotLegends -> {"RWB","Thy", "qFec", "qUri"}]; 


Tiacdesiodineinj[lambda_, t1_] := 
 Module[{cont, tau, t2, tiac}, 
  cont = Drop[Table[Subscript[x, i][tau], {i, 1, 24}], {17, 18}] /. 
    qIInjection[lambda, tau]; 
  tiac[t2_] = Integrate[cont, {tau, 0, t2}]; 
  Join[{Flatten[{"Compart", "TIAC(h)", t1*1.*"day (in Bqs)"}]}, 
   Transpose[
    Join[{Drop[compartmentnamesIinj, {17, 18}]}, {24*
       tiac[10000]}, (3600*24*tiac[#1] & ) /@ t1]]]]

ResponseReport["Iodium", "Injection", "Acute", "Disintegrations", 
   decaycte_, t2_, ___] := Tiacdesiodineinj[decaycte, t2]; 

Tiacdesiodineing[lambda_, t1_, fA_] := 
  Module[{cont, tau, t2, tiac}, 
   cont = Drop[Table[Subscript[x, i][tau], {i, 1, 28}], {17, 18}] /. 
     qIIngestion[lambda, tau, fA]; 
   tiac[t2_] = Integrate[cont, {tau, 0, t2}]; 
   Join[{Flatten[{"Compart", "TIAC(h)", t1*1.*"day (in Bqs)"}]}, 
    Transpose[
     Join[{Drop[compartmentnamesI, {17, 18}]}, {24*
        tiac[100]}, (3600*24*tiac[#1] & ) /@ t1]]]]; 

ResponseReport["Iodium", "Ingestion", "Acute", "Disintegrations", 
   decaycte_, t2_, period_, fA_, ___] := 
  Tiacdesiodineing[decaycte, t2, fA]; 

compiodineinh = {"Blood1", "Blood2", "SalivaryGlands", "Thyroid1", 
   "Thyroid2", "Liver1", "Liver2", "Kidneys1", "Kidneys2", "STWall", 
   "RCContent", "Other1", "Other2", "Other3", "Other4", "UBContent", 
   "Oesophagus", "SIContent", "STContent", "OralCavity", "LCContent", 
   "RSContent", "OesophagusMS", "STContentMS", "SIContentMS", "RT"}; 

Tiacdesiodineinh[lambda_, t1_, fA_, idf_, fr_, sr_, ss_] := 
  Module[{cont, tau, t2, tiac}, 
   cont = Flatten[{Drop[
        Table[Subscript[x, i][tau], {i, 1, 27}], {17, 18}], 
       RTract[tau]}] /. 
     qIInhalation[lambda, tau, fA, idf, fr, sr, ss]; 
   tiac[t2_] = Integrate[cont, {tau, 0, t2}]; 
       Join[{Flatten[{"Compart", "TIAC(h)", t1*1.*"day (in Bqs)"}]}, 
    Transpose[
     Join[{compiodineinh}, {24*tiac[100]}, (3600*24*tiac[#1] & ) /@ 
       t1]]]]; 

ResponseReport["Iodium", "Inhalation", "Acute", "Disintegrations", 
   decaycte_, t2_, period_, fAing_, {fA_, fr_, sr_, ss_}, idf_] := 
  Tiacdesiodineinh[decaycte, t2, fA, idf, fr, sr, ss]; 


(*Cobalt*)

(*Cobalt Injection*)

qCoInjection[lambda_,t_] := AcuteInput1[CompartMatrix[20, Drop[transfercoeffCobalt, -7], lambda], PadRight[{1}, 20], t, x]; 

qCoInjectionBioassay[lambda_,t1_]:= Module[{t, wbInjection, fecInj, uriInj}, 
       {wbInjection[t_], fecInj[t_], uriInj[t_]} = {Total[Table[Subscript[x, i][t], {i, 1, 18}]], Subscript[x, 19][t], 
                Subscript[x, 20][t]} /. qCoInjection[0, t]; Thread[{RWB[t1], qFec[t1], qUri[t1]} -> 
            {wbInjection[t1], fecInj[t1] - fecInj[t1 - 1], uriInj[t1] - uriInj[t1 - 1]}*Exp[(-lambda)*t1]]]; 

qCoInjectionBioassay1[lambda_,t1_]:= Module[{t, wbInjection, fecInj, uriInj}, 
       {wbInjection[t_], fecInj[t_], uriInj[t_]} = {Total[Table[Subscript[x, i][t], {i, 1, 18}]], Subscript[x, 17][t], 
                Subscript[x, 18][t]} /. qCoInjection[0, t]; Thread[{RWB[t1], qFec[t1], qUri[t1]} -> 
            {wbInjection[t1], 2*fecInj[t1] , 12*uriInj[t1] }*Exp[(-lambda)*t1]]]; 

qCoInjectionBioassayConst[decaycte_, t1_, period_] := 
       Module[{t, tau, wb1,  fec1, uri1}, 
          {wb1[t_],  fec1[t_], uri1[t_]} = 
              (qConstant[1, {#1, tau}, t, period] & ) /@ 
                 Evaluate[ExpandAll[{RWB[tau], qFec[tau], qUri[tau]} /. 
                          qCoInjectionBioassay1[decaycte, tau]]]; 
           Thread[{RWB[t1],  qFec[t1], qUri[t1]} -> {wb1[t1], fec1[t1], uri1[t1]}]]; 

qCoInjection1[lambda_,t_]:=Flatten[{RWB[t],If[t<1,0,qFec[t]],If[t<1,0,qUri[t]],Table[Subscript[x,i][t],{i,1,20}]}]/.Flatten[{qCoInjection[lambda,t],
qCoInjectionBioassay[lambda,t]}];

qCoInjectionTable[lambda_, t2_] := Prepend[(Prepend[qCoInjection1[lambda,#1], #1]&)/@Sort[Flatten[Append[Drop[daysirf,1], t2]]], 
Flatten[{"Days", {"WB", "FEC24h", "URI24h"}, Drop[compartmentnamesCo,-5]}]]; 

BioassayReportCobalt["Injection","Acute", lambda_, t2_] := 
    Module[{csreport, bio}, 
            bio = {RWB[t], qFec[t], qUri[t]} /. 
    qCoInjectionBioassay[ lambda,t]; 
  csreport[t1_] = bio /. t -> t1;
        Prepend[(Prepend[csreport[#1], #1] & )/@Sort[Flatten[Append[Drop[daysirf,1], t2]]], 
           {"days", "Wb", "Fec24h", "Urine24h"}]];

BioassayReportCobalt["Injection", "Constant", decaycte_, t2_,period_]:= 
   Module[{csreport, bio}, bio = {RWB[t], qFec[t], qUri[t]} /. 
       qCoInjectionBioassayConst[decaycte, t, period]; csreport[t1_] = bio /. t -> t1; 
     Prepend[(Prepend[csreport[#1], #1] & ) /@Sort[Flatten[Append[Drop[daysirf,1], t2]]], 
      {"days", "Wb", "Fec24h", "Urine24h"}]];   

ResponseReport["Cobalt", "Injection", "Acute", "ResponseFunction", decaycte_, t2_,___] := 
   ExpandAll[qCoInjectionBioassay[decaycte, t2]]; 

ResponseReport["Cobalt", "Injection", "Constant", "ResponseFunction", decaycte_, 
    t2_, period_, ___] := qCoInjectionBioassayConst[decaycte, t2, period]; 

ResponseReport["Cobalt", "Injection", "Acute", "BioassayReport", decaycte_, t2_, 
    ___] := BioassayReportCobalt["Injection", "Acute", decaycte, t2]; 

ResponseReport["Cobalt", "Injection", "Constant", "BioassayReport", decaycte_, t2_, 
    period_, ___] := BioassayReportCobalt["Injection", "Constant", decaycte, t2, 
    period]; 

ResponseReport["Cobalt", "Injection", "Acute", "CompartmentContents", decaycte_, t2_, 
    ___] := qCoInjectionTable[decaycte, t2]; 

ResponseReport["Cobalt", "Injection", "Constant", "CompartmentContents", decaycte_, 
    t2_, period_, ___] := "This option is only applicable for acute intake"; 

ResponseReport["Cobalt", "Injection", "Acute", "GraphicsReport", decaycte_, tminmax_, 
    ___] := LogPlot[Evaluate[ExpandAll[{RWB[t1], qFec[t1], qUri[t1]} /. 
       qCoInjectionBioassay1[decaycte, t1]]], Evaluate[Flatten[{t1, MinMax[tminmax]}]], 
    PlotRange -> All, PlotLegends -> {"RWB", "qFec", "qUri"}]; 

ResponseReport["Cobalt", "Injection", "Constant", "GraphicsReport", decaycte_, 
    tminmax_, period_, ___] := 
   LogPlot[Evaluate[ExpandAll[{RWB[t1], qFec[t1], qUri[t1]} /. 
       qCoInjectionBioassayConst[decaycte, t1, period]]], 
    Evaluate[Flatten[{t1, MinMax[tminmax]}]], PlotRange -> All, 
    PlotLegends -> {"RWB", "qFec", "qUri"}]; 

(*BioassayReportCobalt["Injection", idf_,fA_, fr_, sr_, ss_, lambda_] := BioassayReportCobalt["Injection", fA, lambda];*)

(*Cobalt Ingection*)

qCoIngestion[lambda_,t_, fA_] := AcuteInput1[CompartMatrix[25, transfercoeffCobalt /. kSItoBfA -> 6*(fA/(1 - fA)), lambda], 
   PadLeft[{1}, 25], t, x];

qCoIngestionBioassay[lambda_,t1_, fA_] := Module[{t, wbIngestion, fecIng, uriIng}, 
       {wbIngestion[t_], fecIng[t_], uriIng[t_]} = 
          {Total[Flatten[{Table[Subscript[x, i][t], {i, 1, 18}], Subscript[x, 21][t], Subscript[x, 22][t], Subscript[x, 23][t], 
            Subscript[x, 24][t]}]], Subscript[x, 19][t], Subscript[x, 20][t]} /. qCoIngestion[0, t, fA]; Thread[{RWB[t1], qFec[t1], qUri[t1]} -> 
            {wbIngestion[t1], fecIng[t1]-fecIng[t1-1], uriIng[t1]-uriIng[t1-1]}*Exp[(-lambda)*t1]]]; 

qCoIngestionBioassay1[lambda_,t1_, fA_] := Module[{t, wbIngestion, fecIng, uriIng}, 
       {wbIngestion[t_], fecIng[t_], uriIng[t_]} = 
          {Total[Flatten[{Table[Subscript[x, i][t], {i, 1, 18}], Subscript[x, 21][t], Subscript[x, 22][t], Subscript[x, 23][t], 
            Subscript[x, 24][t]}]], Subscript[x, 17][t], Subscript[x, 18][t]} /. qCoIngestion[0, t, fA]; Thread[{RWB[t1], qFec[t1], qUri[t1]} -> 
            {wbIngestion[t1], 2*fecIng[t1] , 12*uriIng[t1]}*Exp[(-lambda)*t1]]]; 

qCoIngestionBioassayConst[decaycte_, t1_, period_, fA_] := 
     Module[{t, tau,  wb1, fec1, uri1}, 
       {wb1[t_], fec1[t_], uri1[t_]} = 
          (qConstant[1, {#1, tau}, t, period] & ) /@ 
            Evaluate[ExpandAll[{RWB[tau],  qFec[tau], qUri[tau]} /. 
                  qCoIngestionBioassay1[decaycte, tau, fA]]]; 
        Thread[{RWB[t1],  qFec[t1], qUri[t1]} -> {wb1[t1], fec1[t1], uri1[t1]}]]; 

qCoIngestion1[lambda_,t_, fA_] := Flatten[{RWB[t], If[t < 1, 0, qFec[t]], If[t < 1, 0, qUri[t]], 
Table[Subscript[x, i][t], {i, 1, 25}]}] /. Flatten[{qCoIngestion[lambda, t, fA ], 
qCoIngestionBioassay[lambda, t, fA]}]; 

qCoIngestionTable[lambda_,t2_,fA_] := Prepend[(Prepend[qCoIngestion1[lambda, #1, fA ], #1] & )/@Sort[Flatten[Append[Drop[daysirf,1], t2]]], 
Flatten[{"Days", {"WB", "FEC24h", "URI24h"}, compartmentnamesCo}]]; 

BioassayReportCobalt["Ingestion", "Acute", lambda_, t2_, fA_] := Module[{csreport, bio}, 
       bio = {RWB[t], qFec[t], qUri[t]} /. qCoIngestionBioassay[lambda, t, fA]; csreport[t1_] = bio /. t -> t1; 
        Prepend[(Prepend[csreport[#1], #1]&)/@Sort[Flatten[Append[Drop[daysirf,1], t2]]], {"days", "Wb", "Fec24h", "Urine24h"}]]; 

BioassayReportCobalt["Ingestion", "Constant", decaycte_, t2_,period_, fA_] := 
   Module[{csreport, bio}, bio = {RWB[t], qFec[t], qUri[t]} /. 
       qCoIngestionBioassayConst[decaycte, t, period, fA]; 
     csreport[t1_] = bio /. t -> t1; Prepend[(Prepend[csreport[#1], #1] & ) /@ 
      Sort[Flatten[Append[Drop[daysirf,1], t2]]], {"days", "Wb", "Fec24h", "Urine24h"}]]; 

ResponseReport["Cobalt","Ingestion", "Acute", "ResponseFunction", decaycte_, t2_,period_, fA_,___]:=
qCoIngestionBioassay[decaycte, t2, fA]//Chop//ExpandAll;

ResponseReport["Cobalt","Ingestion", "Constant", "ResponseFunction", decaycte_, t2_,  period_,fA_,___]:=
qCoIngestionBioassayConst[decaycte, t2, period, fA];  

ResponseReport["Cobalt","Ingestion", "Acute", "BioassayReport", decaycte_, t2_,  period_,fA_,___]:=
BioassayReportCobalt["Ingestion", "Acute", decaycte, t2, fA] ;

ResponseReport["Cobalt","Ingestion", "Constant", "BioassayReport", decaycte_, t2_, period_,fA_,___]:=
BioassayReportCobalt["Ingestion", "Constant", decaycte, t2, period, fA] ;

ResponseReport["Cobalt","Ingestion", "Acute", "CompartmentContents", decaycte_, t2_, period_, fA_,___]:=
qCoIngestionTable[decaycte,t2, fA];

ResponseReport["Cobalt","Ingestion", "Constant",  "CompartmentContents", decaycte_, t2_, period_, fA_,___]:=
"This function is only available for acute intake";  ;
  
ResponseReport["Cobalt","Ingestion", "Acute", "GraphicsReport", decaycte_, tminmax_,  period_, fA_,___]:=
LogPlot[Evaluate[ExpandAll[{RWB[t1], qFec[t1], qUri[t1]}/.qCoIngestionBioassay1[decaycte, t1, fA]]], 
Evaluate[Flatten[{t1, MinMax[tminmax]}]],PlotRange->All, PlotLegends -> {"RWB", "qFec", "qUri"}];

ResponseReport["Cobalt","Ingestion", "Constant", "GraphicsReport", decaycte_, tminmax_,period_, fA_,___]:=
LogPlot[Evaluate[ExpandAll[{RWB[t1], qFec[t1], qUri[t1]}/.qCoIngestionBioassayConst[decaycte, t1, period, fA]]], 
Evaluate[Flatten[{t1, MinMax[tminmax]}]],PlotRange->All, PlotLegends -> {"RWB", "qFec", "qUri"}];    
(*BioassayReportCobalt["Ingestion", idf_,fA_, fr_, sr_, ss_, lambda_: 0] := BioassayReportCobalt["Ingestion", fA, lambda];*)

(*Cobalt Inhalation*)

qCoInhalation[lambda_, t1_, fA_, idf_,  fr_, sr_, ss_] := Module[{rt, blood, oes, initialconditions, b1Co, transfercoeffCo, 
     xNumbers}, {rt, blood, oes} = RTRetention[idf, fr, sr, ss]; initialconditions = PadRight[{0}, 23]; 
     b1Co = {blood, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, oes, 0, 0}; 
     transfercoeffCo = Drop[transfercoeffCobalt,-3]  /. kSItoBfA -> 6*(fA/(1 - fA)); 
     xNumbers = Flatten[{Table[Subscript[x, i][t1], {i, 1, 23}], RTract[t1]}]; 
     Thread[xNumbers -> Evaluate[xNumbers /. SystemDSolve[CompartMatrix[23, transfercoeffCo], initialconditions, b1Co, t, t1, x] /. 
          RTract[t1] -> Evaluate[rt /. t -> t1]]*Exp[(-lambda)*t1]]]; 

qCoInhalationBioassay[lambda_, t1_, fA_, idf_,  fr_, sr_, ss_] := 
   Module[{qTR1, TRx, rt1, rt, lung, qwbody1, qfec1, quri1, qwbody, qfec24h, quri24h}, 
    qTR1[t_] := qTRRetention[t, idf, fr, sr, ss, 0]; TRx = Table[Subscript[x, i][t], {i, 1, 11}]; 
     rt1 = {"RapidDissolutionSubsystem", "SlowDissolutionSubsystem"} /. qTR1[t]; rt = TRx /. rt1; lung = Drop[TRx, {6, 9}] /. rt1; 
     {qwbody1[t_], qfec1[t_], quri1[t_]} = 
      {Total[Flatten[{Table[Subscript[x, i][t], {i, 1, 18}], Table[Subscript[x, i][t], {i, 21, 23}]}]] + RTract[t], 
        Subscript[x, 19][t], Subscript[x, 20][t]} /. qCoInhalation[0, t, fA, idf,  fr, sr, ss]; 
     {qwbody, qfec24h, quri24h} = {qwbody1[t], qfec1[t] - qfec1[t - 1], quri1[t] - quri1[t - 1]}; 
     Thread[{RTract[t1], RLungs[t1], RWB[t1], qFec[t1], qUri[t1]} -> Exp[(-lambda)*t1]*{Total[Flatten[rt]], Total[Flatten[lung]], 
          qwbody, qfec24h, quri24h} /. t -> t1]]; 

qCoInhalationBioassay1[lambda_, t1_, fA_, idf_,  fr_, sr_, ss_] := 
   Module[{qTR1, TRx, rt1, rt, lung, qwbody1, qfec1, quri1, qwbody, qfec24h, quri24h}, 
    qTR1[t_] := qTRRetention[t, idf, fr, sr, ss, 0]; TRx = Table[Subscript[x, i][t], {i, 1, 11}]; 
     rt1 = {"RapidDissolutionSubsystem", "SlowDissolutionSubsystem"} /. qTR1[t]; rt = TRx /. rt1; lung = Drop[TRx, {6, 9}] /. rt1; 
     {qwbody1[t_], qfec1[t_], quri1[t_]} = 
      {Total[Flatten[{Table[Subscript[x, i][t], {i, 1, 18}], Table[Subscript[x, i][t], {i, 21, 23}]}]] + RTract[t], 
        Subscript[x, 17][t], Subscript[x, 18][t]} /. qCoInhalation[0, t, fA, idf,  fr, sr, ss]; 
     {qwbody, qfec24h, quri24h} = {qwbody1[t], qfec1[t], quri1[t]}; 
     Thread[{RTract[t1], RLungs[t1], RWB[t1], qFec[t1], qUri[t1]} -> Exp[(-lambda)*t1]*{Total[Flatten[rt]], 
     Total[Flatten[lung]], qwbody, 2*qfec24h, 12*quri24h} /. t -> t1]]; 

qCoInhalationBioassayConst[decaycte_, t1_, period_, fA_, idf_, fr_, sr_, ss_] := 
   Module[{t, tau, wb, fec, uri, wb1, fec1, uri1}, 
    {wb[t_], fec[t_], uri[t_]} = 
      {Total[Flatten[{Table[Subscript[x, i][t], {i, 1, 18}], Table[Subscript[x, i][t], {i, 21, 23}]}]] + RTract[t], 
       Subscript[x, 17][t], Subscript[x, 18][t]} /. qCoInhalation[0, t, fA, idf, fr, sr, ss]; 
     {wb1[t_], fec1[t_], uri1[t_]} = (qConstant[1, {#1, tau}, t, period] & ) /@ 
       Evaluate[ExpandAll[{wb[tau]*Exp[(-decaycte)*tau], 
          2*fec[tau]*Exp[(-decaycte)*tau], 12*uri[tau]*Exp[(-decaycte)*tau]}]]; 
     Thread[{RWB[t1], qFec[t1], qUri[t1]} -> {wb1[t1], fec1[t1], uri1[t1]}]]; 

BioassayReportCobalt["Inhalation", "Acute", lambda_, t2_, fA_, idf_, fr_, sr_, ss_] := 
   Module[{csreport}, 
   csreport[t_] = 
      {RTract[t], RLungs[t], RWB[t], qFec[t], qUri[t]} /. 
       qCoInhalationBioassay[lambda, t, fA, idf,  fr, sr, ss]; 
     Prepend[(Prepend[csreport[#1], #1] & ) /@ Sort[Flatten[Append[Drop[daysirf,1], t2]]], 
      {"days", "RespTract", "Lungs", "Wb", "Fec24h", "Urine24h"}]]; 
      
BioassayReportCobalt["Inhalation", "Constant", decaycte_, t2_, period_, fA_, 
    idf_, fr_, sr_, ss_] := Module[{csreport, bio}, 
    bio = {RWB[t], qFec[t], qUri[t]} /. qCoInhalationBioassayConst[decaycte, t, 
        period, fA, idf, fr, sr, ss]; csreport[t1_] = bio /. t -> t1; 
     Prepend[(Prepend[csreport[#1], #1] & ) /@ 
       Sort[Flatten[Append[Drop[daysirf, 1], t2]]], {"days", "Wb", "Fec24h", 
       "Urine24h"}]];

qCoInhalationTable[lambda_, t2_, fA_, idf_,  fr_, sr_, ss_] := 
Module[{solUS, list1, list2}, solUS[t_] = Table[Subscript[x, i][t], {i, 1, 23}] /. qCoInhalation[lambda, t, fA, idf, fr, sr, ss]; 
list1 = BioassayReportCobalt["Inhalation", "Acute", lambda, t2, fA, idf, fr, sr, ss]; 
list2 = Prepend[(solUS[#1] & )/@Sort[Flatten[Append[Drop[daysirf,1], t2]]], Flatten[Drop[compartmentnamesCo, -2]]]; 
Transpose[Join[Transpose[list1], Transpose[list2]]]];

ResponseReport["Cobalt","Inhalation", "Acute", "ResponseFunction", decaycte_, t2_, period_,fAing_,{fA_, fr_, sr_, ss_}, idf_]:=
qCoInhalationBioassay[decaycte, t2, fA, idf, fr, sr, ss];

ResponseReport["Cobalt","Inhalation", "Constant", "ResponseFunction", decaycte_, t2_,period_, fAing_,{fA_, fr_, sr_, ss_}, idf_]:=
qCoInhalationBioassayConst[decaycte, t2, period, fA, idf, fr, sr, ss]; 

ResponseReport["Cobalt","Inhalation", "Acute", "BioassayReport", decaycte_, t2_,period_, fAing_,{fA_, fr_, sr_, ss_}, idf_]:=
BioassayReportCobalt["Inhalation", "Acute", decaycte, t2, fA, idf, fr, sr, ss];

ResponseReport["Cobalt","Inhalation", "Constant", "BioassayReport", decaycte_, t2_, period_, fAing_,{fA_, fr_, sr_, ss_}, idf_]:=
BioassayReportCobalt["Inhalation", "Constant", decaycte, t2, period, fA, idf, fr, sr, ss];

ResponseReport["Cobalt","Inhalation", "Acute", "CompartmentContents", decaycte_, t2_, period_, fAing_,{fA_, fr_, sr_, ss_}, idf_]:=
qCoInhalationTable[decaycte, t2, fA, idf, fr, sr, ss];

ResponseReport["Cobalt","Inhalation", "Constant",  "CompartmentContents", decaycte_, t2_, period_, fAing_, {fA_, fr_, sr_, ss_}, idf_]:=
"Response Function is only applicable for acute intake";
  
ResponseReport["Cobalt", "Inhalation", "Acute", "GraphicsReport", decaycte_, tminmax_, period_, fAing_, {fA_, fr_, sr_, ss_}, idf_]:=
LogPlot[Evaluate[ExpandAll[{RWB[t1], qFec[t1], qUri[t1]}/.qCoInhalationBioassay[decaycte, t1, fA, idf, fr, sr, ss]]], 
Evaluate[Flatten[{t1, MinMax[tminmax]}]],PlotRange->All, PlotLegends -> {"RWB", "qFec", "qUri"}];

ResponseReport["Cobalt","Inhalation", "Constant", "GraphicsReport", decaycte_, tminmax_,period_, fAing_,{fA_, fr_, sr_, ss_}, idf_]:=
LogPlot[Evaluate[ExpandAll[{RWB[t1], qFec[t1], qUri[t1]}/.qCoInhalationBioassayConst[decaycte, t1, period, fA, idf, fr, sr, ss]]], 
Evaluate[Flatten[{t1, MinMax[tminmax]}]],PlotRange->All, PlotLegends -> {"RWB", "qFec", "qUri"}]; 


(* F 18 Injection*)

transfercoeffF = {{1, 2, 4.8}, {2, 1, 8.07}, {1, 3, 0.0088}, {1, 4, 0.054}, {4, 1, 0.109}, {4, 5, 0.045}, {5, 4, 0.0058}, {1, 6, 0.102}, {6, 1, 0.13}, {6, 7, 0.062}, {7, 6, 0.0068}, {1, 8, 0.371},  {8, 1, 0.102}, {8, 9, 0.0167}, {1, 10, 0.068}, {10, 1, 
    0.219}, {10, 11, 0.018}, {1, 12, 0.0053}, {1, 13, 0.0017}}; 
transfercoeffFg ={{1, 2, 4.07}, {2, 1, 7.35}, {1, 3, 0.0085}, {1, 4, 0.052}, {4, 1, 0.1}, {4, 5, 0.042}, {5, 4, 0.0055}, {1, 6, 0.099}, {6, 1, 0.115}, 
  {6, 7, 0.059}, {7, 6, 0.0066}, {1, 8, 0.348}, {8, 1, 0.097}, {8, 9, 0.015}, {1, 10, 0.038}, {10, 1, 0.186}, {10, 11, 0.006}, {1, 12, 0.003}, {1, 13, 0.0016}};


decaycte = 0.0063144867; 

matrixF = CompartMatrix[13, transfercoeffF, decaycte]; 
matrixFg = CompartMatrix[13, transfercoeffFg, decaycte];

initialconditions = {1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; 

daysirf = 
  Sort[Flatten[{14, 15, 45, 120, 180, 365, Range[0, 9], 
     Range[10, 100, 10], Range[200, 1000, 100], 
     Range[2000, 10000, 1000]}]]; 


qF18Injection[t_] := AcuteInput1[matrixF, initialconditions, t, x];
qF18InjectionG[t_] := AcuteInput1[matrixFg, initialconditions, t, x]; 


qF18InjectionComp[t_] = Chop[Table[Subscript[x, i][t], {i, 1, 13}] /. qF18Injection[t]]; 
qF18InjectionTable[t2_] := Chop[Module[{mins}, mins = DeleteDuplicates[Sort[Flatten[{Range[0, 100], t2}]]]; MapThread[Prepend, {Prepend[(qF18InjectionComp[#1] & ) /@ mins, compartmentnamesF], 
        Prepend[mins, "Mins"]}]]]; 

qF18InjectionCompG[t_] = Chop[Table[Subscript[x, i][t], {i, 1, 13}] /. qF18InjectionG[t]]; 
qF18InjectionTableG[t2_] := Chop[Module[{mins}, mins = DeleteDuplicates[Sort[Flatten[{Range[0, 100], t2}]]]; MapThread[Prepend, {Prepend[(qF18InjectionCompG[#1] & ) /@ mins, compartmentnamesF], 
        Prepend[mins, "Mins"]}]]]; 


ResponseReport["Fluorine18", "Injection", "Acute", "AritmeticMean", "CompartmentContents", t2_, ___] := qF18InjectionTable[t2]; 

ResponseReport["Fluorine18", "Injection", "Acute", "AritmeticMean","GraphicsReport", tminmax_, ___] := LogPlot[Evaluate[qF18InjectionComp[t1]], Evaluate[Flatten[{t1, MinMax[tminmax]}]], PlotRange -> All, 
   PlotLegends -> compartmentnamesF]

ResponseReport["Fluorine18", "Injection", "Acute", "AritmeticMean", "ResponseFunction", t_, ___] := ExpandAll[qF18Injection[t]]; 


ResponseReport["Fluorine18", "Injection", "Acute", "GeometricMean", "CompartmentContents", t2_, ___] := qF18InjectionTable[t2]; 

ResponseReport["Fluorine18", "Injection", "Acute", "GeometricMean", "GraphicsReport", tminmax_, ___] := LogPlot[Evaluate[qF18InjectionCompG[t1]], Evaluate[Flatten[{t1, MinMax[tminmax]}]], PlotRange -> All, 
   PlotLegends -> compartmentnamesF]

ResponseReport["Fluorine18", "Injection", "Acute", "GeometricMean", "ResponseFunction", t_, ___] := ExpandAll[qF18InjectionG[t]]; 


qF18InjectionBioassay[t1_] := 
  Module[{t, wb, brain, urine, liver, lungs, 
    heart}, {wb[t_], brain[t_], urine[t_], liver[t_], lungs[t_], 
     heart[t_]} = 
          {Total[Drop[Table[Subscript[x, i][t], {i, 1, 13}], {3}]], 
      Subscript[x, 4][t] + Subscript[x, 5][t] + Subscript[x, 6][t] + 
       Subscript[x, 7][t], Subscript[x, 3][t], 
              Subscript[x, 10][t] + Subscript[x, 11][t], 
      Subscript[x, 13][t], Subscript[x, 12][t]} /. qF18Injection[t]; 
        Thread[{RWB[t1], RBrain[t1], qUri[t1], RLiver[t1], 
      RLungs[t1], RHeart[t1]} -> {wb[t1], brain[t1], urine[t1], 
      liver[t1], lungs[t1], heart[t1]}]]; 



BioassayReportF18["Injection", "Acute", t2_] := 
  Module[{csreport, bio}, 
   bio = {RWB[t], RBrain[t], qUri[t], RLiver[t], RLungs[t], 
      RHeart[t]} /. qF18InjectionBioassay[t]; 
   csreport[t1_] = bio /. t -> t1; 
        Prepend[(Prepend[csreport[#1], #1] & ) /@ 
     Sort[Flatten[Append[Drop[daysirf, 1], t2]]], {"Mins", "Wb", 
     "Brain", "Urine", "Liver", "Lungs", "Heart"}]]; 


ResponseReport["Fluorine18", "Injection", "Acute", "BioassayReport",  t2_, ___] := BioassayReportF18["Injection", "Acute", t2]; 



qF18InjectionCte[t_, period_] := 
  Module[{tau}, (qConstant[1, {#1, tau}, t, period] & ) /@ 
    Evaluate[
     Table[Subscript[x, i][tau], {i, 1, 13}] /. qF18Injection[tau]]]; 
     
qF18InjectionTableCte[t2_, T2_] := Chop[Module[{mins}, mins = DeleteDuplicates[Sort[Flatten[{Range[0, 100], t2}]]]; 
      MapThread[Prepend, {Prepend[(qF18InjectionCte[#1, T2] & ) /@ mins, compartmentnamesF], Prepend[mins, "Mins"]}]]]; 
      
ResponseReport["Fluorine18", "Injection", "Constant", "AritmeticMean", "CompartmentContents", t2_, period_, ___] := 
  qF18InjectionTableCte[t2, period]; 
 
ResponseReport["Fluorine18", "Injection", "Constant", "AritmeticMean", "GraphicsReport", tminmax_, period_, ___]:= LogPlot[Evaluate[qF18InjectionCte[t1, period]], Evaluate[Flatten[{t1, MinMax[tminmax]}]], PlotRange -> All, 
   PlotLegends -> compartmentnamesF]
   
 qF18InjectionCteG[t_, period_] := 
  Module[{tau}, (qConstant[1, {#1, tau}, t, period] & ) /@ 
    Evaluate[
     Table[Subscript[x, i][tau], {i, 1, 13}] /. qF18InjectionG[tau]]]; 
     
qF18InjectionTableCteG[t2_, T2_] := Chop[Module[{mins}, mins = DeleteDuplicates[Sort[Flatten[{Range[0, 100], t2}]]]; 
      MapThread[Prepend, {Prepend[(qF18InjectionCteG[#1, T2] & ) /@ mins, compartmentnamesF], Prepend[mins, "Mins"]}]]]; 
      
ResponseReport["Fluorine18", "Injection", "Constant", "GeometricMean", "CompartmentContents", t2_, period_, ___] := 
  qF18InjectionTableCteG[t2, period]; 
 
ResponseReport["Fluorine18", "Injection", "Constant", "GeometricMean", "GraphicsReport", tminmax_, period_, ___]:= LogPlot[Evaluate[qF18InjectionCteG[t1, period]], Evaluate[Flatten[{t1, MinMax[tminmax]}]], PlotRange -> All, 
   PlotLegends -> compartmentnamesF]

ResponseReport["Fluorine18", "Injection", "Acute", "AritmeticandGeometricMean",  "TIAC", t2_, ___] := Module[{tiac,  tiacG},tiac=Integrate[qF18InjectionComp[t], {t, 0, t2}]/60; tiacG=Integrate[qF18InjectionCompG[ t], {t, 0, t2}]/60;
{compartmentnamesF,tiac,tiacG}];



End[]

Print["OIRModels 1.3   2024-11-28"] 

EndPackage[]

